<?php
/*
 Wettkampfabwicklung, Aktion: hinzufuegen_zeitenexport
 verwendete Templates:
  - 42.hinzufuegen-auszeitenexport.inc.html
*/
if(isset($_GET['gespeicherteloeschen'])){
	unset($_SESSION['zeitenexport2wkmeldung']);
	if(isset($_SESSION['wk_abwickeln']['meldungauszeitenexport'])){
		unset($_SESSION['wk_abwickeln']['meldungauszeitenexport']);
	}
	weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG,'Die exportieren Zeiten wurden gelöscht.');
}

require_once(PFAD_INCLUDE.'class/zeitenexport.inc.php');
$_ze = new zeitenexport;
$_ze->_einst['altersklassen'] = $_altersklassen;

if(isset($_SESSION['zeitenexport2wkmeldung']) and $_SESSION['zeitenexport2wkmeldung'] !== false){
	$export = $_SESSION['zeitenexport2wkmeldung'];
	$wettkampf = $_SESSION['wk_abwickeln']['id'];
	
	# Wettkämpfe holen
	$query = "SELECT w.id, w.wknr, w.mw, w.laenge, w.disziplin, w.jahrgang, w.wkart
				FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
				WHERE a.id = w.abschnittid AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND
				  wkart != 'f' AND wkart != 'z' AND LOCATE('x', w.laenge)<1
				ORDER BY a.nr, w.wknr";
	$_db->holeDaten($query);
	$wettkaempfe = $_db->baueArray('*','id');
	foreach($wettkaempfe as $id => $row){
		$wettkaempfe[$id]['_kurz'] = 'WK'.$row['wknr'].', '.$row['laenge'].'m '.$_lagen[$row['disziplin']].' '.$_geschlechter[$row['mw']];
		$wettkaempfe[$id]['_jahrgaenge'] = $_ze->_holeJahrgaenge($row['jahrgang']);
	}

	# bereits gemeldete Mitglieder holen
	$query = "SELECT id as teilnehmerid, mid    FROM ".DB_PREFIX."meldungen_teilnehmer
				WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
				".(count($export['mitglieder'])>0?' AND mid IN ('.implode(',',array_keys($export['mitglieder'])).')':'');
	$_db->holeDaten($query);
	$vorhandenemitglieder = $_db->baueArray('teilnehmerid','mid');
	# vorhandene Meldungen holen
	$query = "SELECT mt.id as teilnehmerid, mt.mid, ms.meldezeit, ms.wkid, CONCAT(mt.mid,'_',ms.wkid) as schluessel
				FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."meldungen_starts as ms
				WHERE mt.id = ms.teilnehmerid AND mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
				  ".(count($export['mitglieder'])>0?' AND mid IN ('.implode(',',array_keys($export['mitglieder'])).')':'');
	$_db->holeDaten($query);
	$vorhandenemeldungen = $_db->baueArray('*','schluessel');

	# Datenarray vorbereiten (Mitglieder reinsetzen)
	$daten = array();
	foreach($export['mitglieder'] as $mid => $row){
		$row['teilnehmerid'] = false;
		$row['wettkaempfe'] = array();
		$row['nichtzugeordnet'] = array();
		$daten[$mid] = $row;
	}

	# Zeiten zuordnen
	foreach($export['zeiten'] as $row){
		$wks = array();
		foreach($wettkaempfe as $wettk){
			# unpassende Wettkämpfe aussortieren
			if($wettk['mw'] != $daten[$row['mid']]['mw'] and $wettk['mw'] != 'x'){ # falsches Geschlecht
				continue;
			}
			if($wettk['laenge'] != $row['laenge']){ # falsche Länge
				continue;
			}
			if($wettk['disziplin'] != $row['lage']){ # falsche Disziplin
				continue;
			}
			if(!in_array($daten[$row['mid']]['jg'], $wettk['_jahrgaenge'])){ # falscher Jahrgang
				continue;
			}
			$wks[] = $wettk['id'];
		}
		if(count($wks)==0){ # kein passender Wettkampf gefunden
			$row['strecke'] = $row['laenge'].'m '.$_lagen[$row['lage']];
			$daten[$row['mid']]['nichtzugeordnet'][] = $row;
			continue;
		}
		foreach($wks as $wk){
			if(!isset($daten[$row['mid']]['wettkaempfe'][$wk])){
				$daten[$row['mid']]['wettkaempfe'][$wk] = array();
			}
			else{
				foreach($daten[$row['mid']]['wettkaempfe'][$wk] as $wkzeit){
					if($row['zeit'] == $wkzeit['zeit']){ # gleicher Eintrag bereits vorhanden
						continue 2;
					}
				}
			}
			$daten[$row['mid']]['wettkaempfe'][$wk][] = array(
				'zeit' => $row['zeit'],
				'quelle' => 'Export'
			);
		}
	}

	# bei bereits gemeldeten Mitgliedern Teilnehmerid eintragen
	foreach($vorhandenemitglieder as $mid => $teilnehmerid){
		if(!isset($daten[$row['mid']])){
			continue;
		}
		$daten[$mid]['teilnehmerid'] = $teilnehmerid;
	}

	# bei bereits gemeldeten Mitgliedern gespeicherte Meldezeit eintragen
	foreach($vorhandenemeldungen as $row){
		if(!isset($daten[$row['mid']])){ # Mitglied nicht im Export
			continue;
		}
		if(!isset($daten[$row['mid']]['wettkaempfe'])){ # Wettkampf nicht bei den Meldungen des Mitgliedes
			continue;
		}
		if(!isset($daten[$row['mid']]['wettkaempfe'][$row['wkid']])){ # für Wettkampf gemeldet, keine Zeit dafür im Import
			continue;
		}
		if(count($daten[$row['mid']]['wettkaempfe'][$row['wkid']]) == 1){
			if($daten[$row['mid']]['wettkaempfe'][$row['wkid']][0]['zeit'] == $row['meldezeit']){
				$daten[$row['mid']]['wettkaempfe'][$row['wkid']][0]['ignorieren'] = 1;
			}
			else{
				$daten[$row['mid']]['wettkaempfe'][$row['wkid']][] = array(
					'zeit' => $row['meldezeit'],
					'quelle' => 'vorhandene Meldung'
				);
			}
		}
		else{
			$daten[$row['mid']]['wettkaempfe'][$row['wkid']][] = array(
				'zeit' => $row['meldezeit'],
				'quelle' => 'vorhandene Meldung'
			);
		}
	}

	foreach($wettkaempfe as $key => $wettk){
		unset($wettk['_jahrgaenge']);
		$wettkaempfe[$key] = $wettk;
	}
	
	$_SESSION['wk_abwickeln']['meldungauszeitenexport'] = array(
		'daten' => $daten,
		'wettkaempfe' => $wettkaempfe
	);
	$_SESSION['zeitenexport2wkmeldung'] = false;
}

if(isset($_POST['speichern'])){
	$daten = &$_SESSION['wk_abwickeln']['meldungauszeitenexport']['daten'];
	$wks = &$_SESSION['wk_abwickeln']['meldungauszeitenexport']['wettkaempfe'];

	$anzahl = 0;
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	$f = '';
	foreach($daten as $mid => $mitglied){
		# zu speichernde Starts sammeln
		$schreiben = array();
		# Zeiten die bereits Wettkämpfen zugeordnet wurden
		foreach($mitglied['wettkaempfe'] as $wkid => $wk){
			if(count($wk) == 1){
				if(!isset($wk[0]['ignorieren'])){
					$schreiben[$wkid] = $wk[0]['zeit'];
				}
				unset($daten[$mid]['wettkaempfe'][$wkid]);
			}
			else{
				if(!isset($_POST['zeitauswahl'][$mid]) or !isset($_POST['zeitauswahl'][$mid][$wkid])){
					$f .= 'Bitte Zeit wählen ('.$mitglied['name'].', '.$wks[$wkid]['_kurz'].')<br />';
				}
				else{
					if($_POST['zeitauswahl'][$mid][$wkid] != 'i'){
						$zeit = $wk[$_POST['zeitauswahl'][$mid][$wkid]]['zeit'];
						$schreiben[$wkid] = $zeit;
					}
					unset($daten[$mid]['wettkaempfe'][$wkid]);
				}
			}
		}

		# nicht zuzuordnende Zeiten
		foreach($mitglied['nichtzugeordnet'] as $id => $zeit){
			if(!isset($_POST['nichtzugeordnet'][$mid]) or !isset($_POST['nichtzugeordnet'][$mid][$id])){
			}
			elseif($_POST['nichtzugeordnet'][$mid][$id] == '-'){
				unset($daten[$mid]['nichtzugeordnet'][$id]);
			}
			else{ # überprüfen ob für den ausgewählten Wettkampf gemeldet werden kann
				$wkid = $_POST['nichtzugeordnet'][$mid][$id];
				# Geschlecht i.O.?
				if($wks[$wkid]['mw'] != $mitglied['mw'] and $wks[$wkid]['mw'] != 'x'){
					$f .= 'Das Mitglied kann wegen falschen Geschlechts nicht für den gewählten Wettkampf gemeldet werden ('.$mitglied['name'].', '.text_format($zeit['zeit'],'schwimmzeit').', '.$zeit['strecke'].')<br />';
				}
				# für Wettkampf schon gemeldet?
				$pruefen = $schreiben;
				if($mitglied['teilnehmerid'] !== false){
					$query = "SELECT wkid, meldezeit FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$mitglied['teilnehmerid'];
					$_db->holeDaten($query);
					$meldungen = $_db->baueArray('meldezeit', 'wkid');
					foreach($meldungen as $w => $z){
						$pruefen[$w] = $z;
					}
				}
				if(array_key_exists($wkid, $pruefen)){ # Meldung für den Wettkampf bereits vorhanden
					if(isset($pruefen[$wkid]) and $pruefen[$wkid] == $zeit['zeit']){ # Zeiten sind identisch -> ignorieren
						unset($daten[$mid]['nichtzugeordnet'][$id]);
					}
					else{
						$f .= 'Das Mitglied ist für den gewählten Wettkampf schon gemeldet ('.$mitglied['name'].', '.text_format($zeit['zeit'],'schwimmzeit').', '.$zeit['strecke'].', WK'.$wks[$wkid]['wknr'].')<br />';
					}
				}
				else{ # Meldung schreiben
					$schreiben[$wkid] = $zeit['zeit'];
					unset($daten[$mid]['nichtzugeordnet'][$id]);
				}
			}
		}

		# erledigte Mitglieder entfernen
		if(count($daten[$mid]['wettkaempfe'])==0 and count($daten[$mid]['nichtzugeordnet'])==0){
			unset($daten[$mid]);
		}

		# Teilnehmerid holen bzw. Teilnehmer anlegen
		if(count($schreiben)<1){
			continue;
		}
		if($mitglied['teilnehmerid'] === false){ # Teilnehmer anlegen
			$query = "INSERT INTO ".DB_PREFIX."meldungen_teilnehmer (wettkampfid, mid) VALUES (".$_SESSION['wk_abwickeln']['id'].", ".$mitglied['id'].")";
			$_db->fuehreQueryAus($query);
			$teilnehmer = $_db->holeInsertId();
		}
		else{
			$teilnehmer = $mitglied['teilnehmerid'];
		}
		# Daten schreiben
		$query = "INSERT INTO ".DB_PREFIX."meldungen_starts (teilnehmerid, meldezeit, wkid) VALUES ";
		$ds = array();
		foreach($schreiben as $wkid => $zeit){
			$ds[] = "(".$teilnehmer.", ".$zeit.", ".$wkid.")";
		}
		$anzahl += count($ds);
		if(count($ds)>0){
			$delquery = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$teilnehmer." AND wkid IN (".implode(',',array_keys($schreiben)).")";
			$_db->fuehreQueryAus($delquery);
			$query .= implode(', ', $ds);
			$_db->fuehreQueryAus($query);
		}
	}
    
	if(empty($f)){
		$text = 'Es wurde'.($anzahl==1?' 1 Start':'n '.$anzahl.' Starts').' eingetragen';
		unset($_SESSION['wk_abwickeln']['meldungauszeitenexport']);
		unset($_SESSION['zeitenexport2wkmeldung']);
		if($_wkeinst['flags']['pflichtzeitengeprueft'] != 0){
			$_wkeinst['flags']['pflichtzeitengeprueft'] = 0;
			schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
		}
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG, $text);
	}
}

if(isset($_GET['loeschen'])){
	/* 
	Returncodes:
	-1: Fehler, nichts machen
	-2: Wettkampf-Zeile löschen
		x: (mit x>0) ganzes Mitglied löschen (x=ID des Mitgliedes)
	*/
	$teile = explode('_', $_GET['loeschen']);
	$daten = &$_SESSION['wk_abwickeln']['meldungauszeitenexport']['daten'];
	$return = -1;
	if(count($teile) == 1){ # Mitglied löschen
		if(isset($daten[$teile[0]])){
			unset($daten[$teile[0]]);
			$return = $teile[0];
		}
	}
	elseif(count($teile) == 2){ # normaler Wettkampfeintrag
		if(isset($daten[$teile[0]]) and isset($daten[$teile[0]]['wettkaempfe'][$teile[1]])){
			unset($daten[$teile[0]]['wettkaempfe'][$teile[1]]);
			if(count($daten[$teile[0]]['wettkaempfe'])==0 and count($daten[$teile[0]]['nichtzugeordnet'])==0){
				unset($daten[$teile[0]]);
				$return = $teile[0];
			}
			else{
				$return = -2;
			}
		}
	}
	elseif(count($teile) == 3){ # nicht zuzuordnende Zeit
		if(isset($daten[$teile[0]]) and isset($daten[$teile[0]]['nichtzugeordnet'][$teile[1]])){
			unset($daten[$teile[0]]['nichtzugeordnet'][$teile[1]]);
			if(count($daten[$teile[0]]['wettkaempfe'])==0 and count($daten[$teile[0]]['nichtzugeordnet'])==0){
				unset($daten[$teile[0]]);
				$return = $teile[0];
			}
			else{
				$return = -2;
			}
		}
	}

	if(isset($_GET['ajax'])){
		echo $return;
		exit;
	}
	else{
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=hinzufuegen_zeitenexport');
	}
}

if(isset($f)){
	$_tmpl->assign('fehler', $f);
}

$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message');
$_tmpl->tk_javascriptzuweisen('ajaxdatei', '/wettkaempfe/abwickeln.php');
$_tmpl->tk_javascriptzuweisen('onready', "  $('.entfernen').click(function(){
    var loeschen = this.search.substring(this.search.indexOf('&loeschen=')+10);
    var link = this;
    $.get(ajaxdatei, {aktion:'hinzufuegen_zeitenexport', loeschen: loeschen, ajax:1},
    function (status){
      switch(status){
      case '-1': $().message('Der Eintrag konnte nicht gelöscht werden'); break;
      case '-2': $(link.parentNode).remove();break;
      default: $('#m'+status).remove();$('#l'+status).remove(); break;
      }
      return;
    }, 'text');
    return false;
});");

$_tmpl->assign('wettkaempfe',$_SESSION['wk_abwickeln']['meldungauszeitenexport']['wettkaempfe']);
$_tmpl->assign('daten',$_SESSION['wk_abwickeln']['meldungauszeitenexport']['daten']);
$_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-auszeitenexport.inc.html');
# EOF
?>