<?php
require_once('./__inc/_start.inc.php');
$_seite = 0;
if(isset($_GET['changelog'])){
	$_tmpl->assign('ueberschrift','Changelog von tkswim');
	$pfad = './CHANGELOG';
	require_once(PFAD_INCLUDE.'func/parsechangelog.inc.php');
	if(isset($_GET['aeltere'])){
		$changelog = parseChangelog($pfad, false, date('Y-m-d', strtotime('-2 year', getlastmod())), false);
	}
	else{
		$changelog = parseChangelog($pfad, date('Y-m-d', strtotime('-2 year', getlastmod())));
	}
	$_tmpl->assign('changelog',$changelog);
	$_tmpl->assign('aeltere',isset($_GET['aeltere'])?1:0);
	$_inh .= $_tmpl->fetch('tmpl.0.index.inc.html');
}
elseif(isset($_GET['passwortvergessen']) and !isset($_SESSION['eingelogt'])){
	if(isset($_POST['name']) and !empty($_POST['name'])){
		$name = text_format($_POST['name'], 'db');
		$query = "SELECT m.id, l.anmeldename, m.email, m. vorname, m.nachname, m.mw
					FROM ".DB_PREFIX."logins as l LEFT JOIN ".DB_PREFIX."mitglieder as m ON l.id=m.id
					WHERE l.anmeldename = '".$name."' OR m.email = '".$name."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler', 'Die Eingabe konnte nicht erkannt werden, bitte noch einmal versuchen');
			$_tmpl->assign('name', $_POST['name']);
		}
		else{
			$zeile = $_db->holeZeile();
			require_once(PFAD_INCLUDE.'func/generierepasswort.inc.php');
			$passwort = generierePasswort(6);
			$query = "INSERT INTO ".DB_PREFIX."eigenschaften (art, artid, eigenschaft, wert) 
						VALUES ('m', ".$zeile['id'].", 'tmppasswort', '".$passwort."')
						ON DUPLICATE KEY UPDATE wert = VALUES(wert)";
			$_db->fuehreQueryAus($query);
			$variablen = array('passwort' => $passwort);
			if($_POST['name'] == $zeile['email']){
				$variablen['benutzername'] = $zeile['anmeldename'];
			}
			$_email = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
			require_once(PFAD_INCLUDE.'class/mail.inc.php');
			$mail = new email;
			$mail->setzeBetreff($_email['betreff']['zugangsdaten'],false);
			$mail->setzeTextTemplate('sonstiges/0.mail-vergessenespasswort.inc.txt', $_tmpl, $zeile, $variablen);
			$mail->verschickeMail();
			weiterleiten('/?passwortvergessen', 'Das Passwort wurde per Mail verschickt');
		}
	}
	$_inh .= $_tmpl->fetch('sonstiges/0.passwortvergessen.inc.html');
}
elseif(isset($_SESSION['eingelogt']) and !isset($_SESSION['adminlogin'])){
	# Trainingsgruppen
	$query = "SELECT t.id, TIME_FORMAT(t.anfangszeit, '%H:%i') as anfang, t.wochentag, t.kommentar
				FROM ".DB_PREFIX."trainingsgruppen_uebungsleiter as tu LEFT JOIN ".DB_PREFIX."trainingsgruppen as t ON t.id=tu.trainingsgruppenid
				WHERE uebungsleiterid=".$_SESSION['user']['id']."
				ORDER BY t.wochentag, t.anfangszeit";
	$_db->holeDaten($query);
	$trainingsgruppen = false;
	if($_db->holeAnzahl()){
		$daten = $_db->baueArray('*', '#');
		$trainingsgruppen = array();
		foreach($daten as $gruppe){
			$trainingsgruppen[$gruppe['id']] = array(
				'titel' => $_wochentage[$gruppe['wochentag']].', '.$gruppe['anfang'].' Uhr',
				'kommentar' => $gruppe['kommentar']
			);
		}
	}
	$_tmpl->assign('trainingsgruppen', $trainingsgruppen);

	# aktueller Stundennachweis
	$stundennachweisurl = false;
	if($trainingsgruppen !== false){
		require_once(PFAD_INCLUDE.'class/stundennachweise.inc.php');
		$std = new stundennachweise();
		$aktuell = date('Y').'_'.(date('n')<7?1:2);
		if(isset($std->daten[$aktuell])){
			$stundennachweisurl = '/training/stundennachweis'.TKSWIM_DATEIENDUNG.'?aktion=bearbeiten&amp;id='.$aktuell;
		}
		else{
			$stundennachweisurl = '/training/stundennachweis'.TKSWIM_DATEIENDUNG.'?aktion=neu&amp;halbj='.$aktuell;
		}
	}
	$_tmpl->assign('stundennachweisurl', $stundennachweisurl);

	# abzuwickelnde Wettkaempfe
	$abzuwickelndewettkaempfe = false;
	if($_SESSION['flags']['abzuwickelndewettkaempfe']){
		require_once(PFAD_INCLUDE.'func/wettkaempfe_leseabzuwickelndeein.inc.php');
		wettkaempfe_leseAbzuwickelndeEin();
		$abzuwickelndewettkaempfe = $_SESSION['user']['wkabwickeln']['wettkaempfe'];
	}
	$_tmpl->assign('abzuwickelndewettkaempfe', $abzuwickelndewettkaempfe);

	# Hall-of-Fame-Links (es wird immer ein zufälliger aus den 4 50m- und 100m-Strecken und den 200L angezeigt)
	$hoflinks = array(
		'lage=1&laenge=50',  # 50F
		'lage=2&laenge=50',  # 50B
		'lage=3&laenge=50',  # 50R
		'lage=4&laenge=50',  # 50S
		'lage=1&laenge=100', # 100F
		'lage=2&laenge=100', # 100B
		'lage=3&laenge=100', # 100R
		'lage=4&laenge=100', # 100S
		'lage=5&laenge=200'  # 200L
	);
	$_tmpl->assign('halloffame', $hoflinks[array_rand($hoflinks)]);

	$_inh .= $_tmpl->fetch('tmpl.0.index.inc.html');
}
require_once('./__inc/_ende.inc.php');
# EOF
?>