<?php
require_once('./__inc/_start.inc.php');
$_seite = 0;

if(isset($_SESSION['passwortmussgesetztwerden'])){
	$_tmpl->assign('ueberschrift', 'Login');
	if(isset($_POST['passwort1'])){
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		$f .= pruefen($_POST['passwort1'], 'leer', 'Das Passwort fehlt');
		$f .= pruefen($_POST['passwort2'], 'leer', 'Die Wiederholung des Passworts fehlt');
		$f .= pruefen($_POST['passwort1'], 'gleich', 'Die Wiederholung des Passworts stimmt nicht nicht mit dem Passwort überein', $_POST['passwort2']);
		$f .= pruefen($_POST['passwort1'],'passwort','Das Passwort muss aus mindestens je eines der Zeichen [a-zöäüß], [A-ZÖÄÜ] und [0-9] enthalten und mindestens 8 Zeichen lang sein.');
		if(!empty($f)){
			$_tmpl->assign('fehler', $f);
		}
		else{
			$query = "SELECT salz FROM ".DB_PREFIX."logins WHERE id = ".$_SESSION['user']['id'];
			$_db->holeDaten($query);
			$salz = $_db->holeWert();
			$pw_form = text_format($_POST['passwort1'],'nichts');
			if(is_null($salz)){
				require_once(PFAD_INCLUDE.'func/generierepasswort.inc.php');
				$salz = generierePasswort(10);
				$salzpw = md5($salz.$pw_form);
				$query = "UPDATE ".DB_PREFIX."logins SET salz='".$salz."', passwort = '".$salzpw."' WHERE id = ".$_SESSION['user']['id'];
			}
			else{
				$salzpw = md5($salz.$pw_form);
				$query = "UPDATE ".DB_PREFIX."logins SET passwort = '".$salzpw."' WHERE id = ".$_SESSION['user']['id'];
			}
			$_db->fuehreQueryAus($query);
			
			# Passwort ist geändert, den User wieder Rechte geben und ihn dahinleiten wo er hinwollte
			$_SESSION['user']['rechte'] = $_SESSION['rechte_tmp'];
			unset($_SESSION['rechte_tmp']);
			$vonseite = isset($_SESSION['vonseite'])?$_SESSION['vonseite']:'/';
			$vonseite = $vonseite=='?passwortvergessen'?'/':$vonseite;
			unset($_SESSION['vonseite']);
			weiterleiten($vonseite);
		}
	}
	$_inh .= $_tmpl->fetch('sonstiges/0.login-passwortneusetzen.inc.html');
}


if(isset($_POST['anmelden'])){
	if(!isset($_COOKIE['TKSWIMSESSIONID'])){
		$_SESSION['fehler'] = 'ohne Cookies ist kein Einloggen möglich';
	}
	elseif($_POST['loginanmeldename']=='admin' AND $_POST['loginpasswort'] == TKSWIM_ADMINPASSWORT){
		$_SESSION['eingelogt'] = 1;
		$_SESSION['adminlogin'] = 1;
		$_SESSION['user']['name'] = 'admin';
		$_SESSION['user']['realname'] = 'admin';
		$_SESSION['user']['letzterzugriff'] = time();
		$_SESSION['user']['id'] = 0;
		if(isset($_SESSION['versuche'])){
			unset($_SESSION['versuche']);
		}
		unset($_SESSION['vonseite']);
		if(isset($_SESSION['fehler'])){
			unset($_SESSION['fehler']);
		}
		# erfolgreichen Versuch loggen
		$daten = 'Name: admin, IP: '.$_SERVER['REMOTE_ADDR'].', UA: '.$_SERVER['HTTP_USER_AGENT'];
		$daten = preg_replace("/((\015\012)|(\015)|(\012))+/",' ',$daten);
		trigger_error('[login] erfolgreicher Login|'.$daten, E_USER_NOTICE);
		# und ab zur Adminseite
		weiterleiten('/admin.php');
	}
	else{
		# gibt es einen User mit den eingegebenen Daten?
		$query = "SELECT m.id, l.anmeldename, l.salz, l.passwort, CONCAT(m.vorname,' ',m.nachname) as realname,
					  m.homeverzeichnisid, DATE_FORMAT(letzterlogin, '%Y%m%d%H%i%S') as letzterlogin
					FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."logins as l ON m.id=l.id
					WHERE l.anmeldename = '".text_format($_POST['loginanmeldename'],'db')."' AND
					  l.freigeschaltet = 1 AND m.ausgetreten IS NULL";
		$_db->holeDaten($query);

		$loginok = false;
		$mid = false;
		$passwortmussgesetztwerden = false;
		if($_db->holeAnzahl() == 1){
			$row = $_db->holeZeile();
			$mid = $row['id'];
			$pw_form = text_format($_POST['loginpasswort'],'nichts');
			if(!is_null($row['salz'])){
				$pw_form = $row['salz'].$pw_form;
			}
			if(md5($pw_form) == $row['passwort']){
				$loginok = true;
				# altes Passwort in gesalzener Form speichern
				if(is_null($row['salz'])){
					require_once(PFAD_INCLUDE.'func/generierepasswort.inc.php');
					$salz = generierePasswort(10);
					$salzpw = md5($salz.$pw_form);
					$query = "UPDATE ".DB_PREFIX."logins SET salz='".$salz."', passwort = '".$salzpw."' WHERE id = ".$row['id'];
					$_db->fuehreQueryAus($query);
				}
			}
		}
		if($mid !== false){ # nachschauen ob ein tmp-Passwort vorhanden ist
			$query = "SELECT wert FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND artid = ".$mid." AND eigenschaft = 'tmppasswort'";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() == 1){
				$tmppw = $_db->holeWert();
				$pw_form = text_format($_POST['loginpasswort'],'nichts');
				if($pw_form == $tmppw){
					$loginok = true;
					$passwortmussgesetztwerden = true;
				}
			}	
		}

		if($loginok){ # User gefunden, Daten in $_SESSION schreiben
			$_SESSION['user']['name'] = $row['anmeldename'];
			$_SESSION['user']['realname'] = $row['realname'];
			$_SESSION['user']['letzterlogin'] = $row['letzterlogin'];
			$_SESSION['user']['letzterzugriff'] = time();
			$_SESSION['user']['id'] = $row['id'];
			# homeverzeichnis speichern und vorher ggf. neue erzeugen
			if(is_null($row['homeverzeichnisid'])){
				$query = "INSERT INTO ".DB_PREFIX."verzeichnisse (userid, rechte, name, parentid) VALUES
							(".$row['id'].", 'rwx------', '".$row['anmeldename']."', 1)"; # 1 ist das Verzeichnis "home"
				$_db->fuehreQueryAus($query);
				$_SESSION['user']['homeverzeichnis'] = $_db->ergebnis['insertid'];
				$query = "UPDATE ".DB_PREFIX."mitglieder SET homeverzeichnisid = ".$_db->ergebnis['insertid']." WHERE id = ".$row['id'];
				$_db->fuehreQueryAus($query);
			}
			else{
				$_SESSION['user']['homeverzeichnis'] = $row['homeverzeichnisid'];
			}
			# weitere Session-Werte anlegen
			$_SESSION['eingelogt'] = 1;
			$_SESSION['flags'] = array();
			$_SESSION['suche'] = array(
				'einst' => array('einstspeichern' => 1),
				'formular' => 'einfach'
			);
			# Rechte und Rechtegruppen des Users holen
			$query = "SELECT rgr.rechteid as id
						FROM ".DB_PREFIX."rechtegruppen_rechte as rgr, ".DB_PREFIX."rechtegruppen_mitglieder as rgm
						WHERE rgm.mitgliedid = ".$_SESSION['user']['id']." AND rgm.rechtegrid = rgr.rechtegrid GROUP BY id";
			$_db->holeDaten($query);
			$_SESSION['user']['rechte'] = $_db->baueArray('id','#');
			$query = "SELECT rechtegrid as id FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$_SESSION['user']['id'];
			$_db->holeDaten($query);
			$_SESSION['user']['rechtegruppen'] = $_db->baueArray('id','#');
			# Zeitpunkt des Logins speichern
			$query = "UPDATE ".DB_PREFIX."logins SET letzterlogin = NOW() WHERE id = ".$_SESSION['user']['id'];
			$_db->fuehreQueryAus($query);
			# userspezifische Einstellungen laden
			if(file_exists(PFAD_INIDATEIEN.'userconf_'.$_SESSION['user']['id'].'.ini')){
				$_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_'.$_SESSION['user']['id'].'.ini', true);
				if($_einst['globaleeinstellungen']['sicherheitsabfragenabschalten']){
					$_SESSION['hinweis'] = 'Achtung, die Sicherheitsabfragen vor Löschaktionen sind deaktiviert!';
				}
			}
			# Darstellungsoptionen speichern
			$_SESSION['darstellung'] = array(
				'hintergrund' => file_exists(PFAD_HTTP.'src/img/hintergrund.png'),
				'favicon'     => file_exists(PFAD_HTTP.'src/img/favicon.ico')
			);
			# abzuwickelnde Wettkämpfe einlesen
			require_once(PFAD_INCLUDE.'func/wettkaempfe_leseabzuwickelndeein.inc.php');
			wettkaempfe_leseAbzuwickelndeEin();
			$_tmpl->assign('wettkaempfe',$_SESSION['user']['wkabwickeln']['wettkaempfe']);

			# erfolgreichen Versuch loggen (wenn vorher fehlgeschlagene Versuche da waren)
			if(isset($_SESSION['versuche'])){
				$daten = 'Name: '.$_POST['loginanmeldename'].', IP: '.$_SERVER['REMOTE_ADDR'].', UA: '.$_SERVER['HTTP_USER_AGENT'];
				$daten = preg_replace("/((\015\012)|(\015)|(\012))+/",' ',$daten);
				trigger_error('[login] erfolgreicher Login|'.$daten, E_USER_NOTICE);
			}
			# aufraeumen
			if(isset($_SESSION['versuche'])){
				unset($_SESSION['versuche']);
			}
			
			if(isset($_SESSION['fehler'])){
				unset($_SESSION['fehler']);
			}
			# tmp-Passwort entsorgen
			$query = "DELETE FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND artid = ".$_SESSION['user']['id']." AND eigenschaft = 'tmppasswort'";
			$_db->fuehreQueryAus($query);
			
			if($passwortmussgesetztwerden){
				$_SESSION['rechte_tmp'] = $_SESSION['user']['rechte'];
				$_SESSION['user']['rechte'] = array();
				$_SESSION['passwortmussgesetztwerden'] = true;
				weiterleiten('/login'.TKSWIM_DATEIENDUNG, 'Der Login war erfolgreich');
			}

			# Zielseite ermitteln
			$vonseite = isset($_SESSION['vonseite'])?$_SESSION['vonseite']:'/';
			unset($_SESSION['vonseite']);

			# und ab zur Herkunftsseite
			weiterleiten($vonseite);
		}
		else{
			# fehlgeschlagenen Versuch loggen
			$daten = 'Name: '.$_POST['loginanmeldename'].', IP: '.$_SERVER['REMOTE_ADDR'].', UA: '.$_SERVER['HTTP_USER_AGENT'];
			$daten = preg_replace("/((\015\012)|(\015)|(\012))+/",' ',$daten);
			trigger_error('[login] fehlgeschlagener Login|'.$daten, E_USER_WARNING);

			if(!isset($_SESSION['versuche'])){
				$_SESSION['versuche'] = 1;
			}
			else{
				$_SESSION['versuche']++;
			}
			# warten und dann Fehlermeldung zuweisen
			if($_SESSION['versuche'] <= 2){
				sleep(0.2);
			}
			elseif($_SESSION['versuche'] <= 10){
				sleep(1);
			}
			else{
				sleep(10);
			}
			$_SESSION['fehler'] = 'falsche Daten';
		}
	}
}
require_once('./__inc/_ende.inc.php');
# EOF
?>