<?php
require_once('../__inc/_start.inc.php');
$_seite = 65;
$erlaubt = prueferechte('s_bilder_anzeigen');
$_tmpl->assign('ueberschrift', 'Bilder');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
/*
s_bilder_anzeigen	651	Bilder - anzeigen
s_bilder_bearbeiten	652	Bilder - eigene bearbeiten
s_bilder_allebearbeiten	653	Bilder - alle bearbeiten
s_bilder_kommentarebearbeiten	654	Bilder - Kommentare bearbeiten
s_bilder_meldungenbearbeiten	655	Bilder - Meldungen bearbeiten
*/

	require_once(PFAD_INCLUDE.'class/bilder.inc.php');
	$_bilder = new bilder;
	$_bilder->_db = &$_db;

	$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
	switch($_GET['aktion']){
	case 'bildbearbeiten':
		$query = "SELECT id, albumid, name, breite, hoehe, fotograf, IF(breite<hoehe,0,1) as querformat
					FROM ".DB_PREFIX."bilder_bilder
					WHERE id = '".text_format($_GET['id'], 'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler', 'das Bild existiert nicht');
		}
		$bild = $_db->holeZeile();
		# Besitzer holen
		$query = "SELECT besitzer FROM ".DB_PREFIX."bilder_alben WHERE id = ".$bild['albumid'];
		$_db->holeDaten($query);
		$besitzer = $_db->holeWert();
		if($besitzer != $_SESSION['user']['id'] and !pruefeRechte('s_bilder_allebearbeiten')){
			$_inh = T_KEINZUGRIFF;
			break;
		}
		# Fotografen holen
		$query = "SELECT id, CONCAT(vorname,' ',nachname) as name FROM ".DB_PREFIX."mitglieder
					WHERE ausgetreten IS NULL".(!is_null($bild['fotograf'])?" OR id=".$bild['fotograf']:'')."
					ORDER BY nachname, vorname";
		$_db->holeDaten($query);
		$fotografen = $_db->baueArray('name', 'id');
		$_tmpl->assign('fotografen', $fotografen);

		# Markierungen holen
		$query = "SELECT mid, CONCAT(vorname, ' ', nachname) as name
					FROM ".DB_PREFIX."bilder_markierungen as bm LEFT JOIN ".DB_PREFIX."mitglieder as m ON bm.mid=m.id
					WHERE bildid = ".$bild['id']."
					ORDER BY nachname, vorname ";
		$_db->holeDaten($query);
		$markierungen = $_db->baueArray('name', 'mid');
		$_tmpl->assign('markierungen', $markierungen);

		if(isset($_POST['datenaendern'])){
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			$f .= pruefen($_POST['name'], 'leer', 'Der Dateiname fehlt');
			$f .= pruefen($_POST['name'], 'maxlaenge', 'Der Dateiname ist zu kurz (max 50 Zeichen)',50);
			$f .= pruefen($_POST['name'], 'regexpr', 'Der Dateiname ist ungültig', '^[a-z0-9._-]+$');
			if(!empty($_POST['fotograf'])){
				$f .= pruefen($_POST['fotograf'], 'wertemenge', 'Der Fotograf ist ungültig', array_keys($fotografen));
			}
			if(empty($f)){
				$query = "UPDATE ".DB_PREFIX."bilder_bilder
							SET name = '".text_format($_POST['name'],'db')."',
							  fotograf = ".(empty($_POST['fotograf'])?'NULL':$_POST['fotograf'])."
							WHERE id = ".$bild['id'];
				$_db->fuehreQueryAus($query);
				weiterleiten('/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion=bild&id='.$bild['id'], 'Die Änderungen wurden gespeichert');
			}
			else{
				$_tmpl->assign('fehler', $f);
				$bild['name'] = $_POST['name'];
				$bild['fotograf'] = $_POST['fotograf'];
			}
		}
		if(isset($_POST['markierungweg']) and is_array($_POST['markierungweg']) and count($_POST['markierungweg'])>0){
			$l = array();
			foreach($_POST['markierungweg'] as $id){
				$l[] = "'".text_format($id, 'db')."'";
			}
			$query = "DELETE FROM ".DB_PREFIX."bilder_markierungen WHERE bildid = ".$bild['id']." AND mid IN (".implode(',',$l).")";
			$_db->fuehreQueryAus($query);
			weiterleiten('/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion=bild&id='.$bild['id'], 'Die gewählten Markierungen wurden gelöscht');
		}
		if(isset($_GET['loeschen']) and isset($_GET['sicher'])){
			$query = "DELETE FROM ".DB_PREFIX."bilder_kommentare WHERE bildid = ".$bild['id'];
			$_db->fuehreQueryAus($query);
			$query = "DELETE FROM ".DB_PREFIX."bilder_markierungen WHERE bildid = ".$bild['id'];
			$_db->fuehreQueryAus($query);
			$query = "DELETE FROM ".DB_PREFIX."bilder_bilder WHERE id = ".$bild['id'];
			$_db->fuehreQueryAus($query);
			weiterleiten('/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion=album&id='.$bild['albumid'], 'Das Bild wurde gelöscht');
		}
		if(isset($_GET['drehen']) and in_array($_GET['drehen'],array('gegen','im'))){

			if(count($markierungen)>0){
				# Abmessungen vorher holen
				$query = "SELECT id, breite, hoehe FROM ".DB_PREFIX."bilder_bilder WHERE id = ".$bild['id'];
				$_db->holeDaten($query);
				$vorher = $_db->holeZeile();
			}
			$verzeichnis = $_bilder->holeVerzeichnis($bild['albumid']);
			$tmpname = $_bilder->dreheBild($verzeichnis.$bild['id'].'.jpg', $_GET['drehen']);
			$_bilder->erzeugeKleineBilder($tmpname, $bild['id'], $verzeichnis, false);
			if(count($markierungen)>0){
				# Abmessungen hinterher holen
				$query = "SELECT id, breite, hoehe FROM ".DB_PREFIX."bilder_bilder WHERE id = ".$bild['id'];
				$_db->holeDaten($query);
				$hinterher = $_db->holeZeile();
				# Markierungen holen
				$query = "SELECT mid, pos_x, pos_y FROM ".DB_PREFIX."bilder_markierungen WHERE bildid = ".$bild['id'];
				$_db->holeDaten($query);
				$ma = $_db->baueArray('*', 'mid');
				$faktor = $hinterher['hoehe']/$vorher['breite'];
				$richtung = $_GET['drehen']=='gegen'?'g':'i';
				$y_max = $hinterher['hoehe'];
				$x_max = $hinterher['breite'];
				# neue Positionen berechnen
				foreach($ma as $mid => $m){
					$x_neu = round($richtung=='g'?$m['pos_y']*$faktor:$x_max-$m['pos_y']*$faktor);
					$y_neu = round($richtung=='g'?$y_max-$m['pos_x']*$faktor:$m['pos_x']*$faktor);
					$query = "UPDATE ".DB_PREFIX."bilder_markierungen SET pos_x = ".$x_neu.", pos_y = ".$y_neu."
								WHERE bildid = ".$bild['id']." AND mid = ".$m['mid'];
					$_db->fuehreQueryAus($query);
				}
			}
			weiterleiten('/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion=bild&id='.$bild['id'], 'Das Bild wurde gedreht');
		}
		$_tmpl->assign('bild', $bild);
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'bild',frage:'Soll das Bild wirklich gelöscht werden?',ajax:false});");
		$_inh .= $_tmpl->fetch('sonstiges/65.bilder-bildbearbeiten.inc.html');
		break;

	case 'person':
		$query = "SELECT vorname, nachname, id FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){			
			$_tmpl->assign('fehler', 'das Mitglied existiert nicht');
			break;
		}
		$mitgl = $_db->holeZeile();
		$_tmpl->assign('m', $mitgl);

		# Album holen (sofern angegeben)
		$album = false;
		if(isset($_GET['album'])){
			$query = "SELECT id, name FROM ".DB_PREFIX."bilder_alben WHERE id = '".text_format($_GET['album'],'db')."'";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() == 1){
				$album = $_db->holeZeile();
			}
		}
		$_tmpl->assign('album', $album);

		$query = "SELECT b.id as bid, DATE_FORMAT(b.angelegt,'%Y%m%d%H%i%S') as angelegt, b.name, a.id as albumid
					FROM (".DB_PREFIX."bilder_markierungen as m LEFT JOIN ".DB_PREFIX."bilder_bilder as b ON m.bildid=b.id)
					  LEFT JOIN ".DB_PREFIX."bilder_alben as a ON b.albumid=a.id
					  WHERE mid = ".$mitgl['id'].($album!==false?' AND b.albumid='.$album['id']:'')." 
					  ORDER BY a.datum DESC, b.name";
		$_db->holeDaten($query);
		$_tmpl->assign('anz', $_db->holeAnzahl());
		$_tmpl->assign('bilder', $_db->baueArray('*', 'bid'));
		$_inh .= $_tmpl->fetch('sonstiges/65.bilder-person.inc.html');
		break;

	case 'bild':
		$query = "SELECT b.id, b.albumid, b.name as bildname, b.breite, b.hoehe, CONCAT(m.vorname,' ',m.nachname) as name, b.fotograf,
					  DATE_FORMAT(b.angelegt,'%Y%m%d%H%i%S') as angelegt
					FROM ".DB_PREFIX."bilder_bilder as b LEFT JOIN ".DB_PREFIX."mitglieder as m ON b.fotograf=m.id
					WHERE b.id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler', 'Das Bild existiert nicht');
			break;
		}
		$bild = $_db->holeZeile();
		$_tmpl->assign('bild', $bild);

		# Album
		$query = "SELECT DATE_FORMAT(a.datum, '%d.%m.%Y') as datum, CONCAT(m.vorname,' ',m.nachname) as name, a.besitzer, a.name as albumname
					FROM ".DB_PREFIX."bilder_alben as a LEFT JOIN ".DB_PREFIX."mitglieder as m ON a.besitzer=m.id
					WHERE a.id = ".$bild['albumid'];
		$_db->holeDaten($query);
		$album = $_db->holeZeile();
		$_tmpl->assign('album', $album);
		$_bearbeiten = ((prueferechte('s_bilder_bearbeiten') and $album['besitzer'] == $_SESSION['user']['id']) or prueferechte('s_bilder_allebearbeiten'));
		$_tmpl->assign('_bearbeiten', $_bearbeiten);

		# zurück-ID
		$query = "SELECT id, name FROM ".DB_PREFIX."bilder_bilder
					WHERE albumid = ".$bild['albumid']." AND name < (SELECT name FROM ".DB_PREFIX."bilder_bilder WHERE id = ".$bild['id'].")
					ORDER BY name DESC LIMIT 1";
		$_db->holeDaten($query);
		$_tmpl->assign('zurueckid', $_db->holeWert());
		# weiter-ID
		$query = "SELECT id, name FROM ".DB_PREFIX."bilder_bilder
					WHERE albumid = ".$bild['albumid']." AND name > (SELECT name FROM ".DB_PREFIX."bilder_bilder WHERE id = ".$bild['id'].")
					ORDER BY name ASC LIMIT 1";
		$_db->holeDaten($query);
		$_tmpl->assign('weiterid', $_db->holeWert());

		# Kommentare
		$query = "SELECT k.autor, CONCAT(m.vorname,' ',m.nachname) as name, text, DATE_FORMAT(zeitpunkt, '%e. %M %Y, %H:%i') as zeit,
					  CONCAT(bildid, '_', autor, '_', DATE_FORMAT(zeitpunkt, '%Y%m%d%H%i%S')) as loeschid
					FROM ".DB_PREFIX."bilder_kommentare as k LEFT JOIN ".DB_PREFIX."mitglieder as m ON k.autor=m.id
					WHERE bildid = ".$bild['id']." ORDER BY zeitpunkt ASC";
		$_db->holeDaten($query);
		$_tmpl->assign('kommentare', $_db->baueArray('*','#'));

		# Markierungen
		$query = "SELECT CONCAT(m.vorname,' ',m.nachname) as name, b.mid, b.pos_x-50 as x, b.pos_y-50 as y
					FROM ".DB_PREFIX."bilder_markierungen as b LEFT JOIN ".DB_PREFIX."mitglieder as m ON b.mid=m.id
					WHERE bildid = ".$bild['id']." ORDER BY pos_x, pos_y";
		$_db->holeDaten($query);
		$markierungen = $_db->baueArray('*','#');
		$_tmpl->assign('markierungen', $markierungen);
		#  in dem Album bereits markiert
		$query = "SELECT DISTINCT ma.mid as id, CONCAT(m.vorname, ' ', m.nachname) as name
					FROM (".DB_PREFIX."bilder_markierungen as ma LEFT JOIN ".DB_PREFIX."bilder_bilder as b ON ma.bildid=b.id)
					  LEFT JOIN ".DB_PREFIX."mitglieder as m ON ma.mid=m.id
					WHERE albumid = ".$bild['albumid']." ORDER BY m.nachname, m.vorname";
		$_db->holeDaten($query);
		$imalbummarkiert = $_db->baueArray('name','id');
		foreach($markierungen as $row){
			unset($imalbummarkiert[$row['mid']]);
		}
		$_tmpl->assign('imalbummarkiert', $imalbummarkiert);

		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
		if(prueferechte('s_bilder_kommentarebearbeiten')){
			$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschenknopf a').tkswim_loeschfrage({art:'bilderkommentare',frage:'Soll der Kommentar wirklich gelöscht werden?',elternelement:'p'});");
		}
		$_tmpl->tk_javascriptzuweisen('onready', "\$().tkswim_bildermarkieren(".$bild['id'].");");
		$_inh = $_tmpl->fetch('sonstiges/65.bilder-bild.inc.html');
		break;

	case 'kommentarloeschen':
		if(!pruefeRechte('s_bilder_kommentarebearbeiten')){
			$_inh = T_KEINZUGRIFF;
			break;
		}
		if(isset($_GET['id'])){
			list($bild, $user, $zeit) = explode('_', $_GET['id']);
			if(!isset($_GET['sicher'])){
				$_tmpl->assign('frage','Sollen der Kommentar wirklich gelöscht werden?');
				$_tmpl->assign('query','aktion=kommentarloeschen');
				$_tmpl->assign('neinquery', 'aktion=bild&id='.$bild);
				$_tmpl->assign('url', '/sonstiges/bilder'.TKSWIM_DATEIENDUNG);
				$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
				break;
			}
			else{
				list($bild, $user, $zeit) = explode('_', $_GET['id']);
				$query = "DELETE FROM ".DB_PREFIX."bilder_kommentare
							WHERE
							  bildid = '".text_format($bild,'db')."' AND
							  autor = '".text_format($user,'db')."' AND
							  zeitpunkt = '".text_format($zeit,'db')."'";
				$_db->fuehreQueryAus($query);
				weiterleiten('/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion=bild&id='.$bild, 'Der Kommentar wurde gelöscht');
			}
		}
		break;

	case 'bildkommentieren':
		$query = "SELECT id FROM ".DB_PREFIX."bilder_bilder WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler', 'Das Bild existiert nicht');
			break;
		}
		$bildurl = '/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion=bild&id='.$_GET['id'];
		if(!isset($_POST['kommentar']) or empty($_POST['kommentar']) or strlen($_POST['kommentar'])>20000){
			weiterleiten($bildurl);
		}
		$query = "INSERT INTO ".DB_PREFIX."bilder_kommentare SET
					bildid = ".$_GET['id'].",
					autor  = ".$_SESSION['user']['id'].",
					zeitpunkt = NOW(),
					text = '".text_format($_POST['kommentar'],'db')."'";
		$_db->fuehreQueryAus($query);
		weiterleiten($bildurl, 'Der Kommentar wurde gespeichert');

	case 'albumloeschen':
		if(!pruefeRechte('s_bilder_bearbeiten') or !isset($_GET['id'])){
			$_inh = T_KEINZUGRIFF;
			break;
		}
		$query = "SELECT id, besitzer, name FROM ".DB_PREFIX."bilder_alben WHERE id = '".text_format($_GET['id'], 'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler', 'Das Album existiert nicht');
			break;
		}
		$album = $_db->holeZeile();
		if(!isset($_GET['sicher'])){
			$_tmpl->assign('frage','Sollen das Album »'.text_format($album['name'],'html').'« wirklich gelöscht werden?');
			$_tmpl->assign('query','aktion=albumloeschen');
			$_tmpl->assign('neinquery', 'aktion=albumbearbeiten&id='.$_GET['id']);
			$_tmpl->assign('url', '/sonstiges/bilder'.TKSWIM_DATEIENDUNG);
			$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
		}
		else{
			$_allebearbeiten = pruefeRechte('s_bilder_allebearbeiten');
			if(!$_allebearbeiten and $album['besitzer'] != $_SESSION['user']['id']){
				$_inh = T_KEINZUGRIFF;
				break;
			}
			# Löschen
			#  IDs der Bilder zu dem Album holen
			$query = "SELECT id FROM ".DB_PREFIX."bilder_bilder WHERE albumid = ".$album['id'];
			$_db->holeDaten($query);
			#   wenn Bilder vorhanden Kommentare, Markierungen und die Bilder selbst entsorgen
			if($_db->holeAnzahl() > 0){
				$bilderids = implode(',', $_db->baueArray('id', '#'));
				$query = "DELETE FROM ".DB_PREFIX."bilder_kommentare WHERE bildid IN (".$bilderids.")";
				$_db->fuehreQueryAus($query);
				$query = "DELETE FROM ".DB_PREFIX."bilder_markierungen WHERE bildid IN (".$bilderids.")";
				$_db->fuehreQueryAus($query);
				$query = "DELETE FROM ".DB_PREFIX."bilder_bilder WHERE albumid = ".$album['id'];
				$_db->fuehreQueryAus($query);
				# Bilddateien löschen
				$verzeichnis = $_bilder->holeVerzeichnis($album['id'], false);
				$bilder = glob($verzeichnis.'*');
				foreach($bilder as $bild){
					unlink($bild);
				}
				rmdir($verzeichnis);
			}
			#   Album selbst in die ewigen Jagdgründe schicken
			$query = "DELETE FROM ".DB_PREFIX."bilder_alben WHERE id = ".$album['id'];
			$_db->fuehreQueryAus($query);
			weiterleiten('/sonstiges/bilder'.TKSWIM_DATEIENDUNG, 'Das Album wurde gelöscht');
		}
		break;

	case 'albumanlegen':
	case 'albumbearbeiten':
		if(!pruefeRechte('s_bilder_bearbeiten')){
			$_inh = T_KEINZUGRIFF;
			break;
		}
		$_besitzerbearbeiten = pruefeRechte('s_bilder_allebearbeiten');
		if($_besitzerbearbeiten){
			# User holen
			$query = "SELECT id, CONCAT(nachname,', ',vorname) as name FROM ".DB_PREFIX."mitglieder
						WHERE ausgetreten IS NULL ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			$user = $_db->baueArray('name', 'id');
			$_tmpl->assign('user', $user);
		}
		if(!isset($_POST['speichern'])){
			if($_GET['aktion'] == 'albumanlegen'){
				$daten = array(
					'datum' => date('d.m.Y'),
					'name'  => '',
					'besitzer' => $_SESSION['user']['id']
				);
			}
			else{
				$query = "SELECT id, DATE_FORMAT(datum,'%d.%m.%Y') as datum, name, besitzer
							FROM ".DB_PREFIX."bilder_alben WHERE id = '".text_format($_GET['id'], 'db')."'";
				$_db->holeDaten($query);
				if($_db->holeAnzahl() != 1){
					$_tmpl->assign('fehler', 'Das Album existiert nicht');
					break;
				}
				$daten = $_db->holeZeile();
				if($daten['besitzer'] != $_SESSION['user']['id'] and !$_besitzerbearbeiten){
					$_inh = T_KEINZUGRIFF;
					break;
				}
			}
		}
		else{
			$f = '';
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f .= pruefen($_POST['datum'], 'leer', 'das Datum fehlt');
			$f .= pruefen($_POST['datum'], 'datum', 'das Datum ist ungültig');
			$f .= pruefen($_POST['name'], 'leer', 'der Name fehlt');
			$f .= pruefen($_POST['name'], 'maxlaenge', 'der Name ist zu lang (max 100 Zeichen)', 100);
			if($_besitzerbearbeiten){
				$f .= pruefen($_POST['besitzer'], 'leer', 'der Besitzer fehlt');
				$f .= pruefen($_POST['besitzer'], 'maxlaenge', 'der Besitzer ist ungültig', array_keys($user));
			}
			$daten = $_POST;
			if(!empty($f)){
				$_tmpl->assign('fehler', $f);
			}
			else{
				if($_GET['aktion'] == 'albumanlegen'){
					$query = "INSERT INTO ".DB_PREFIX."bilder_alben (datum, name, besitzer, angelegt) VALUES
								('".text_format($_POST['datum'],'dbdatum')."',
								 '".text_format($_POST['name'],'db')."',
								 ".($_besitzerbearbeiten?$_POST['besitzer']:$_SESSION['user']['id']).",
								 NOW())";
				}
				else{
					if($daten['besitzer'] != $_SESSION['user']['id'] and !$_besitzerbearbeiten){
						$_inh = T_KEINZUGRIFF;
						break;
					}
					$query = "UPDATE ".DB_PREFIX."bilder_alben SET
								  datum = '".text_format($_POST['datum'],'dbdatum')."',
								  name = '".text_format($_POST['name'],'db')."',
								  besitzer = ".($_besitzerbearbeiten?$_POST['besitzer']:$_SESSION['user']['id'])."
								WHERE id = ".$_GET['id'];


				}
				$_db->fuehreQueryAus($query);
				$ziel = '/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion=album&id='.(($_GET['aktion']=='albumanlegen')?$_db->holeInsertId():$_GET['id']);
				weiterleiten($ziel, 'Das Album wurde '.($_GET['aktion']=='albumanlegen'?'angelegt':'geändern'));
			}
		}
		$_tmpl->assign('daten', $daten);
		$_tmpl->assign('_besitzerbearbeiten', $_besitzerbearbeiten);
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "\$('.datumwahl').tkswim_datumwahl();");
		$_inh = $_tmpl->fetch('sonstiges/65.bilder-albumformular.inc.html');
		break;

	case 'bilderhochladen':
		if(!pruefeRechte('s_bilder_bearbeiten')){
			$_inh = T_KEINZUGRIFF;
			break;
		}
		$_tmpl->assign('zielid', 'bilder_upload');
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "\$('form').tkswim_uploadformular();");
		$_inh .= $_tmpl->fetch('sonstiges/64.dateien-uploadformular.inc.html');
		# schon hochgeladene Bilder anzeigen
		$hgldat = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
		$vorhandenebilder = array();
		foreach($hgldat as $systemname => $wert){
			list($zeit,$userid,$originalname) = explode('|',$wert);
			if($userid != $_SESSION['user']['id']){
				continue;
			}
			$endung = substr($originalname, strrpos($originalname, '.')+1);
			if(!in_array($endung, array('jpg','jpeg','gif','png'))){
				continue;
			}
			$vorhandenebilder[] = $originalname;
		}
		rsort($vorhandenebilder);
		if(count($vorhandenebilder)>0){
			$_inh .= '<hr /><h3>bereits hochgeladene Bilder</h3><ul>';
			$_inh .= '<li>'.implode('</li><li>', $vorhandenebilder).'</li>';
			$_inh .= '</ul>';
		}
		break;

	case 'bilderimportieren':
		$query = "SELECT a.id, DATE_FORMAT(a.datum, '%e. %M %Y') as datum, a.name, CONCAT(m.vorname,' ',m.nachname) as besitzer,
					  DATE_FORMAT(a.angelegt,'%Y%m%d%H%i%S') as angelegt, a.besitzer as besitzerid
					FROM ".DB_PREFIX."bilder_alben as a LEFT JOIN ".DB_PREFIX."mitglieder as m ON a.besitzer = m.id
					WHERE a.id = '".text_format($_GET['id'], 'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler', 'Das Album existiert nicht');
			break;
		}
		$album = $_db->holeZeile();
		if($album['besitzerid'] != $_SESSION['user']['id'] and !pruefeRechte('s_bilder_allebearbeiten')){
			$_inh = T_KEINZUGRIFF;
			break;
		}
		$_tmpl->assign('album', $album);
		$hgldat = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
		$vorhandenebilder = array();
		foreach($hgldat as $systemname => $wert){
			list($zeit,$userid,$originalname) = explode('|',$wert);
			if($userid != $_SESSION['user']['id']){
				continue;
			}
			$endung = substr($originalname, strrpos($originalname, '.')+1);
			if(!in_array($endung, array('jpg','jpeg','gif','png'))){
				continue;
			}
			$vorhandenebilder[$systemname] = $originalname;
		}
		asort($vorhandenebilder);
		$anzvorhanden = count($vorhandenebilder);

		if(isset($_POST['bilder']) and is_array($_POST['bilder'])){
			$importieren = array();
			foreach($_POST['bilder'] as $bild){
				if(!array_key_exists($bild, $vorhandenebilder)){
					continue;
				}
				$importieren[] = $bild;
			}
			if(count($importieren)>0){
				ini_set('max_execution_time', 0);
				$verzeichnis = $_bilder->holeVerzeichnis($_GET['id'], true);
				$hgldat = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
				foreach($importieren as $tmpname){
					$query = "INSERT INTO ".DB_PREFIX."bilder_bilder SET
								  albumid  = ".$_GET['id'].",
								  name     = '".text_format($vorhandenebilder[$tmpname],'db')."',
								  angelegt = NOW()";
					$_db->fuehreQueryAus($query);
					$bid = $_db->holeInsertId();
					$_bilder->erzeugeKleineBilder($tmpname, $bid, $verzeichnis);
					unset($hgldat[$tmpname]);
					$anzvorhanden--;
					unlink(PFAD_TMP.$tmpname);
				}
				require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
				schreibe_ini_datei(PFAD_INIDATEIEN.'dateien_tmp.ini', $hgldat, false);
				weiterleiten('/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion='.($anzvorhanden>0?'bilderimportieren':'album').'&id='.$_GET['id'], 'Die Bilder wurden dem Album hinzugefügt');
			}
		}

		$_tmpl->assign('bilder', $vorhandenebilder);
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery');
		$_tmpl->tk_javascriptzuweisen('onready', "\$('.alle').click(function(){\$('input[name=\"bilder[]\"]').attr('checked','checked');return false;});");
		$_inh = $_tmpl->fetch('sonstiges/65.bilder-bilderimportiern.inc.html');
		break;

	case 'album':
		$_ajax = isset($_POST['letztesbild']);
		$query = "SELECT a.id, DATE_FORMAT(a.datum, '%d.%m.%Y') as datum, a.name, besitzer, CONCAT(m.vorname,' ',m.nachname) as besitzername
					FROM ".DB_PREFIX."bilder_alben as a LEFT JOIN ".DB_PREFIX."mitglieder as m ON a.besitzer=m.id
					WHERE a.id = '".text_format($_GET['id'], 'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			if($_ajax){
				exit;
			}
			$_tmpl->assign('fehler', 'Das Album existiert nicht');
			break;
		}
		$album = $_db->holeZeile();
		$_tmpl->assign('album', $album);

		$_bearbeiten = ((prueferechte('s_bilder_bearbeiten') and $album['besitzer'] == $_SESSION['user']['id']) or prueferechte('s_bilder_allebearbeiten'));
		$_tmpl->assign('_bearbeiten', $_bearbeiten);

		# Bilder holen
		if($_ajax){
			$query = "SELECT DATE_FORMAT(b.angelegt,'%Y%m%d%H%i%S') as angelegt, b.id, b.name,
						  (SELECT COUNT(*) FROM ".DB_PREFIX."bilder_kommentare WHERE bildid=b.id) as anzkoment, b.albumid
						FROM ".DB_PREFIX."bilder_bilder as b
						WHERE albumid = ".$album['id']." AND b.name > '".text_format($_POST['letztesbild'],'db')."' ORDER BY b.name LIMIT 0,10";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() < 1){
				exit;

			}
			$bilder = $_db->baueArray('*','id');
			$html = '';
			foreach($bilder as $id => $bild){
				$html .= '<p>';
				if($_SESSION['user']['letzterlogin'] < $bild['angelegt']){
					$html .= '<span class="neu">neu </span>';
				}
				$html .= '<strong>'.$bild['name'].'</strong><br />';
				$html .= '<a href="'.ROOT.'/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'?aktion=bild&id='.$bild['id'].'"><img src="
				'.ROOT.(TKSWIM_KURZLINKS?'/bilder/bild_'.$bild['albumid'].'_'.$bild['id'].'_kl.jpg':'/_bilder.php?art=bilder&amp;album='.$bild['albumid'].'&id='.$bild['id'].'_kl').'" alt="" /></a><br />';
				$html .= '<span class="beschriftung">'.($bild['anzkoment']==1?'1 Kommentar':$bild['anzkoment'].' Kommentare').'</span>';
				$html .= '</p>';
			}
			echo $html;
			$_db->speichereGeaenderteTabellen();
			exit;
		}

		$query = "SELECT DATE_FORMAT(b.angelegt,'%Y%m%d%H%i%S') as angelegt, b.id, b.name,
					  (SELECT COUNT(*) FROM ".DB_PREFIX."bilder_kommentare WHERE bildid=b.id) as anzkoment, b.albumid
					FROM ".DB_PREFIX."bilder_bilder as b
					WHERE albumid = ".$album['id']." ORDER BY b.name ".(isset($_GET['allezeigen'])?'':'LIMIT 0,30');
		$_db->holeDaten($query);
		$_tmpl->assign('bilderzahl', $_db->holeAnzahl());
		$_tmpl->assign('bilder', $_db->baueArray('*','id'));

		# markierte Personen holen
		$query = "SELECT m.id, CONCAT(m.vorname, ' ', m.nachname) as name, COUNT(*) as anz
					FROM (".DB_PREFIX."bilder_markierungen as bm LEFT JOIN ".DB_PREFIX."bilder_bilder as bb ON bm.bildid=bb.id) LEFT JOIN ".DB_PREFIX."mitglieder as m ON bm.mid=m.id
					WHERE bb.albumid = ".$album['id']."
					GROUP BY m.id
					ORDER BY m.nachname, m.vorname";
		$_db->holeDaten($query);
		$_tmpl->assign('anzmarkiertepersonen', $_db->holeAnzahl());
		$_tmpl->assign('markiertepersonen', $_db->baueArray('*','#'));

		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.tkswim,jquery.endless-scroll,jquery.message');
		$_tmpl->tk_javascriptzuweisen('ajaxdatei', '/sonstiges/bilder.php?aktion=album&id='.$_GET['id']);
		$_tmpl->tk_javascriptzuweisen('onready',"$('.nojs').css('display','none');");
		$_tmpl->tk_javascriptzuweisen('onready', "\$(document).endlessScroll({
    callback: function(p){
      if(window.tk_endlessScroll_fertig){ return; }
      var letztesbild = $('div#bilderuebersicht p:last strong').text();
      $.post(ajaxdatei, {letztesbild: letztesbild}, function(data){
        if(data == ''){ window.tk_endlessScroll_fertig = true; }
        \$('div#bilderuebersicht').append(data);
      });
    }
  });");
		$_inh = $_tmpl->fetch('sonstiges/65.bilder-album.inc.html');
		break;

	default:
		$query = "SELECT a.id, DATE_FORMAT(a.datum,'%d.%m.%Y') as datum, a.name as albumname, CONCAT(m.vorname,' ',m.nachname) as besitzer,
					  DATE_FORMAT(a.angelegt,'%Y%m%d%H%i%S') as angelegt, b.id as bildid, COUNT(b.id) as anz
					FROM (".DB_PREFIX."bilder_alben as a LEFT JOIN ".DB_PREFIX."bilder_bilder as b ON a.id=b.albumid)
					  LEFT JOIN ".DB_PREFIX."mitglieder as m ON a.besitzer=m.id
					GROUP BY a.id ORDER BY a.datum DESC, a.name";
		$_db->holeDaten($query);
		$alben = $_db->baueArray('*', 'id');
		$_tmpl->assign('alben', $alben);
		$_inh = $_tmpl->fetch('sonstiges/65.bilder-index.inc.html');
		break;
	}
} # Ende des Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>