<?php
require_once('../__inc/_start.inc.php');
$_seite = 62;
$erlaubt = pruefeRechte('s_einstellungen');
$_tmpl->assign('ueberschrift','Einstellungen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
require_once(PFAD_INCLUDE.'class/einstellungen.inc.php');
require_once(PFAD_INCLUDE.'conf/user-ini.php');
require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');

$einst = new einstellungen('user',$_SESSION['user']['id']);
$einst->db = &$_db;
#$einst->einlesen();
#$einst->aktualisiereUserinidateien();
$_tmpl->assign('bodyid','einstellungen');
if(!file_exists($einst->userconfpfad.$einst->userdatei)){
	unset($_GET['aktion']);
}
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'pdfraenderdatei':
	require_once(PFAD_INCLUDE.'class/pdf.inc.php');
	$pdf = new tkpdf(10);
	$x = 595.28;
	$y = 841.89;
	$pdf->setLineStyle(3);
	$pdf->line($x/2, 0, $x/2, $y);
	$pdf->line(0, $y/2, $x, $y/2);
	$pdf->addText(40,780,14,'Anleitung');
	$pdf->addText(40,760,10,'- Drucken dieser Datei');
	$y = 740;
	$text = '- Abmessern der Abstände zwischen Linienende und Seitenrand';
	$erste = true;
	while($text != ''){
		$text = $pdf->addTextWrap(40+($erste?0:7), $y, $x/2-40+($erste?0:7), 10, $text);
		$erste = false;
		$y -= 15;
	}
	$text = '- Eintragen der Werte (in mm) in die Einstellungen (in der Form: »oben, rechts, unten, links«)';
	$y -= 5;
	$erste = true;
	while($text != ''){
		$text = $pdf->addTextWrap(40+($erste?0:7), $y, $x/2-42+($erste?0:7), 10, $text);
		$erste = false;
		$y -= 15;
	}
	$pdf->tk_autor = $_SESSION['user']['realname'];
	$pdf->tk_titel = 'Testdatei zum Ermitteln der PDF-Seitenränder';
	$pdf->tkstream('testdatei.pdf');

case 'gruppeloeschen':
	if(!pruefeRechte('m_anzeigen_adresse')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id'])){
		weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen','Die übergebenen Parameter waren ungültig.');
	}
	elseif(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll die Gruppe wirklich gelöscht werden?');
		$_tmpl->assign('query','aktion=gruppeloeschen&id='.$_GET['id']);
		$_tmpl->assign('neinquery','aktion=terminbenachrichtigungen');
		$_tmpl->assign('url', '/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html').'<hr />';
		break;
	}
	else{
		$rg = $einst->benachrichtigungLoeschen($_GET['id'],'gruppe');
		if($rg === true){
			$text = 'Die Gruppe wurde entfernt.';
		}
		elseif($rg == -1 or $rg == -2){
			$text = 'Die übergebenen Parameter waren ungültig.';
		}
		elseif($rg == -3){
			$text = 'Die Gruppe war nicht vorhanden.';
		}
		weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen',$text);
	}
case 'geburtstagsgruppenbearbeiten':
	if(!pruefeRechte('m_anzeigen_adresse')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	require_once(PFAD_INCLUDE.'func/holetrainingsgruppen.inc.php');
	$gruppendaten = holeTrainingsgruppen(true);
	$gruppendaten['vorstand'] = 'Vorstand';
	$gruppendaten['uebungsleiter'] = 'Übungsleiter';
	$gruppendaten['kampfrichter'] = 'Kampfrichter';
	if(!isset($_POST['speichern'])){
		list(,$gruppen,) = explode('|',$_einst['emailbenachrichtigung']['terminbenachrichtigungen'],3);
		list(,$gruppen) = explode(':',$gruppen);
		if(!empty($gruppen)){
			$_tmpl->assign('vorhanden',explode(',',$gruppen));
		}
	}
	else{
		$ids = array();
		$erlaubte = array_keys($gruppendaten);
		$erlaubte[] = 'uebungsleiter';
		$erlaubte[] = 'kampfrichter';
		$erlaubte[] = 'vorstand';
		if(isset($_POST['gruppen']) and is_array($_POST['gruppen'])){
			foreach($_POST['gruppen'] as $gr){
				if(!in_array($gr,$erlaubte)){
					continue;
				}
				$ids[] = $gr;
			}
		}
		$einst->benachrichtigungHinzufuegen($ids, 'gruppe');
		weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen','Die Gruppen wurden gespeichert.');
	}

	$_tmpl->assign('gruppen',$gruppendaten);
	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-geburtstagsgruppen.inc.html');
	break;

case 'terminloeschen':
	if(!pruefeRechte('s_kalender_anzeigen')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id'])){
		weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen','Die übergebenen Parameter waren ungültig.');
	}
	else{
		$rg = $einst->benachrichtigungLoeschen($_GET['id'],'termin');
		if($rg === true){
			$text = 'Der Termin wurde gelöscht.';
		}
		elseif($rg == -1 or $rg == -2){
			weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen','Die übergebenen Parameter waren ungültig.');
		}
		elseif($rg == -3){
			$text = 'Der Termin war nicht vorhanden.';
		}
		if(isset($_GET['einst'])){
			weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen',$text);
		}
		else{
			weiterleiten('/_terminlookup.php?id='.$_GET['id'],$text);
		}
	}

case 'terminhinzufuegen':
	if(!pruefeRechte('s_kalender_anzeigen')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id'])){
		weiterleiten('/sonstiges/kalender'.TKSWIM_DATEIENDUNG,'Die übergebenen Parameter waren ungültig.');
		exit;
	}
	else{
		$rg = $einst->benachrichtigungHinzufuegen($_GET['id'],'termin');
		if($rg === true){
			$text = 'Der Termin wurde gespeichert.';
		}
		elseif($rg == -1 or $rg == -2){
			weiterleiten('/sonstiges/kalender'.TKSWIM_DATEIENDUNG,'Die übergebenen Parameter waren ungültig.');
		}
		elseif($rg == -3){
			$text = 'Der Termin war bereits gespeichert.';
		}
		weiterleiten('/_terminlookup.php?id='.$_GET['id'],$text);
	}
	break;

case 'geburtstagspersonloeschen':
	if(!pruefeRechte('m_anzeigen_adresse')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id'])){
		weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen','Die übergebenen Parameter waren ungültig.');
	}
	elseif(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll die Person wirklich gelöscht werden?');
		$_tmpl->assign('query','aktion=geburtstagspersonloeschen&id='.$_GET['id']);
		$_tmpl->assign('neinquery','aktion=terminbenachrichtigungen');
		$_tmpl->assign('url', '/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html').'<hr />';
	}
	else{
		$rg = $einst->benachrichtigungLoeschen($_GET['id'],'person');
		if($rg === true){
			$text = 'Das Mitglied wurde gelöscht.';
		}
		elseif($rg == -1 or $rg == -2){
			$text = 'Die übergebenen Parameter waren ungültig.';
		}
		elseif($rg == -3){
			$text = 'Das Mitglied war nicht gespeichert.';
		}
		weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen',$text);
	}
	break;

case 'geburtstagspersonhinzufuegen':
	if(!pruefeRechte('m_anzeigen_adresse')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id'])){
		require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
		$_inh .= mitgliedwaehlen('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG, 'aktion=geburtstagspersonhinzufuegen');
	}
	else{
		$rg = $einst->benachrichtigungHinzufuegen($_GET['id'],'person');
		if($rg === true){
			weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen','Das Mitglied wurde gespeichert.');
		}
		elseif($rg == -1 or $rg == -2){
			weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=geburtstagspersonhinzufuegen','Die übergebenen Parameter waren ungültig.');
		}
		elseif($rg == -3){
			weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=terminbenachrichtigungen','Das Mitglied war bereits gespeichert.');
		}
	}
	break;

case 'terminbenachrichtigungen':
	if(!pruefeRechte('s_kalender_anzeigen','m_anzeigen_name')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('alletermine', $_einst['emailbenachrichtigung']['analletermineerinnern']);
	$_tmpl->assign('daten',$einst->holeBenachrichtigungen());
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschentermin').tkswim_loeschfrage({frage:'Soll die Erinnerung an den Termin wirklich gelöscht werden?',ajax:false,elternelement:'li'});");
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschengruppe').tkswim_loeschfrage({frage:'Soll die Gruppe wirklich aus den Geburtstagserinnerungen entfernt werden?',ajax:false,elternelement:'li'});");
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschenperson').tkswim_loeschfrage({frage:'Soll das Mitglied wirklich aus den Geburtstagserinnerungen entfernt werden?',ajax:false,elternelement:'li'});");
	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-termineindex.inc.html');
	break;

case 'emailpasswort':
	if(!isset($_POST['speichern'])){
		$query = "SELECT email FROM ".DB_PREFIX."mitglieder WHERE id = ".$_SESSION['user']['id'];
		$_db->holeDaten($query);
		$daten = $_db->holeZeile();
	}
	else{
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f .= pruefen($_POST['email'],'email','Die E-Mailadresse ist ungültig');
		$f .= pruefen($_POST['email'],'maxlaenge','Die E-Mailadresse ist zu lang (max. 50 Zeichen)',50);
		if(!empty($_POST['passwort']) OR !empty($_POST['passwort2'])){
			$f .= pruefen($_POST['passwort'],'gleich','Die Passwörter sind nicht gleich',$_POST['passwort2']);
			$f .= pruefen($_POST['passwort'],'passwort','Das Passwort muss aus mindestens je eines der Zeichen [a-zöäüß],
						[A-ZÖÄÜ] und [0-9] enthalten und mindestens 8 Zeichen lang sein.');
		}
		if(empty($f)){
			$query = "UPDATE ".DB_PREFIX."mitglieder SET email = '".text_format($_POST['email'],'db')."' WHERE id = ".$_SESSION['user']['id'];
			$_db->fuehreQueryAus($query);
			$pwgeaendert = false;
			if(!empty($_POST['passwort']) OR !empty($_POST['passwort2'])){
				$query = "SELECT salz FROM ".DB_PREFIX."logins WHERE id = ".$_SESSION['user']['id'];
				$_db->holeDaten($query);
				$dbsalz = $_db->holeWert();	
				if(is_null($dbsalz)){
					require_once(PFAD_INCLUDE.'func/generierepasswort.inc.php');
					$salz = generierePasswort(10);
					$query = "UPDATE ".DB_PREFIX."logins 
								SET 
								  passwort = '".md5($salz.$_POST['passwort'])."',
								  salz = '".$salz."'
								WHERE id = ".$_SESSION['user']['id'];			
				}
				else{	
					$query = "UPDATE ".DB_PREFIX."logins SET passwort = MD5(CONCAT(salz,'".$_POST['passwort']."')) WHERE id = ".$_SESSION['user']['id'];
				}
				$_db->fuehreQueryAus($query);
				$pwgeaendert = true;
			}
			$meldung = 'Die E-Mailadresse '.($pwgeaendert?'und das Passwort wurden':'wurde').' geändert.';
			weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG,$meldung);
		}
		else{
			$daten = $_POST;
			$_tmpl->assign('fehler',$f);
		}
	}
	$_tmpl->assign('daten',$daten);
	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-emailpasswort.inc.html');
	break;

case 'anzeigen':
	$_werte = parse_ini_file($einst->userconfpfad.$einst->userdatei, true);
	$anzeige = array();
	foreach($_usereinstellungen as $mid => $modul){
		if(!pruefeRechte($_usereinstellungen_module[$mid]['recht'])){
			continue;
		}
		if(!isset($anzeige[$mid])){
			$anzeige[$mid] = array(
				'id' => $mid,
				'titel' => $_usereinstellungen_module[$mid]['titel'],
				'beschreibung' => $_usereinstellungen_module[$mid]['beschreibung'],
				'_einstellungen' => array()
			);
		}
		foreach($modul as $oid => $option){
			if(isset($option['recht']) and !pruefeRechte($option['recht'])){
				continue;
			}
			$wert = '';
			switch($option['art']){
			case 'datei':
				$fh = fopen($option['verzeichnis'].$_werte[$mid][$oid],'r');
				$anfang = fread($fh,200);
				fclose($fh);
				preg_match('~\[\[sichtbar=(1|0)\|name=(.*?)\]\]~',$anfang,$match);
				$wert = $match[2];
				#$wert = 'foobar';
				break;
			case 'bool':
				$wert = $_werte[$mid][$oid]==1?'ja':'nein';
				break;
			case 'text':
				$von = array('<i>', '</i>', '<b>', '</b>');
				$nach1 = array('[i]', '[/i]', '[b]', '[/b]');
				$nach2 = array('<em>', '</em>', '<strong>', '</strong>');
				if($_werte[$mid][$oid] == ''){
					$wert = '<em>[leer]</em>';
				}
				else{
					$wert = str_replace($von, $nach1, $_werte[$mid][$oid]);
					$wert = text_format($wert, 'html');
					$wert = str_replace($nach1, $nach2, $wert);
				}
				break;
			case 'select':
				$wert = text_format($option['werte'][$_werte[$mid][$oid]], 'html');
				break;
			}
			$anzeige[$mid]['_einstellungen'][$oid] = array(
				'id' => $oid,
				'titel' => $option['titel'],
				'beschreibung' => $option['beschreibung'],
				'wert' => $wert
			);
		}
	}
	$_tmpl->assign('anzeige', $anzeige);
	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-anzeigen.inc.html');
	break;

case 'aendern':
	foreach($_usereinstellungen as $mid => $modul){
		foreach($modul as $oid => $option){
			if($option['art'] != 'datei'){
				continue;
			}
			$fh = opendir($option['verzeichnis']);
			$tmp_dateien = array();
			while(false !== ($file = readdir($fh))){
				if($file == '.' or $file == '..' or is_dir($file)){
					continue;
				}
				$tmp_dateien[] = $file;
			}
			closedir($fh);
			$dateien = array();
			foreach($tmp_dateien as $datei){
				$fh = fopen($option['verzeichnis'].$datei,'r');
				$anfang = fread($fh,300);
				fclose($fh);
				preg_match('~\[\[sichtbar=(1|0)\|name=(.*?)\]\]~',$anfang,$match);
				if(isset($match[1]) and $match[1] == 1){
					$dateien[$datei] = $match[2];
				}
			}
			$_usereinstellungen[$mid][$oid]['werte'] = $dateien;
		}
	}
	$_tmpl->assign('daten',  $_usereinstellungen);
	$_tmpl->assign('module', $_usereinstellungen_module);

	if(isset($_POST['speichern'])){
		$f = '';
		foreach($_usereinstellungen as $mid => $modul){
			if(!pruefeRechte($_usereinstellungen_module[$mid]['recht'])){
				continue;
			}
			foreach($modul as $oid => $option){
				if(isset($option['recht']) and !pruefeRechte($option['recht'])){
					continue;
				}
				switch($_usereinstellungen[$mid][$oid]['art']){
				case 'bool':
					$_POST['werte'][$mid][$oid] = isset($_POST['werte'][$mid][$oid])?1:0;
					break;
				case 'text':
					if(preg_match('~^'.$_usereinstellungen[$mid][$oid]['form'].'$~', $_POST['werte'][$mid][$oid], $match) == 0){
						$f .= $_usereinstellungen[$mid][$oid]['fehler'].'<br />';
					}
					break;
				case 'select':
				case 'datei':
					if(!array_key_exists($_POST['werte'][$mid][$oid], $_usereinstellungen[$mid][$oid]['werte'])){
						$f .= $_usereinstellungen[$mid][$oid]['fehler'].'<br />';
					}
					break;
				}
			}
		}
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$_tmpl->assign('werte', $_POST['werte']);
		}
		else{
			$_werte = parse_ini_file($einst->userconfpfad.$einst->userdatei, true);
			foreach($_usereinstellungen as $mid => $modul){
				if(!isset($_POST['werte'][$mid]) or !pruefeRechte($_usereinstellungen_module[$mid]['recht'])){
					continue;
				}
				foreach($modul as $oid => $option){
					if(isset($option['recht']) and !pruefeRechte($option['recht'])){
						continue;
					}
					
					if(isset($_POST['werte'][$mid][$oid])){
						$_werte[$mid][$oid] = $_POST['werte'][$mid][$oid];
					}
				}
			}
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei($einst->userconfpfad.$einst->userdatei, $_werte, true);
			$einst->cronjobEinstellungenEinlesen();
			weiterleiten('/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'?aktion=anzeigen','Die Einstellungen wurden gespeichert');
		}
	}
	else{
		$_werte = parse_ini_file($einst->userconfpfad.$einst->userdatei, true);
		if(count($_werte)<1){
			$_werte = array();
			foreach($_usereinstellungen as $mid => $modul){
				$_werte[$mid] = array();
				foreach($modul as $oid => $option){
					$_werte[$mid][$oid] = $option['standard'];
				}
			}
			$_SESSION['hinweis'] = 'Es sind noch keine Einstellungen gespeichert, die Standardeinstellungen wurden geladen.';
		}
		$_tmpl->assign('werte', $_werte);
	}

	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-formular.inc.html');
	break;

default:
	if(!file_exists($einst->userconfpfad.$einst->userdatei)){
		copy($einst->userconfpfad.'userconf_default.ini',$einst->userconfpfad.$einst->userdatei);
		chmod($einst->userconfpfad.$einst->userdatei, 0666);
		$daten = parse_ini_file($einst->userconfpfad.$einst->userdatei,true);
		$daten['stundennachweis']['name'] = $_SESSION['user']['realname'];
		schreibe_ini_datei($einst->userconfpfad.$einst->userdatei,$daten,true);
	}
	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-index.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>