<?php
require_once('../__inc/_start.inc.php');
$_seite = 42;
$erlaubt = pruefeRechte('w_abwickeln_eigenemeldung','w_abwickeln_anzeigen','w_abwickeln_eigenekarimeldung');
if(isset($_GET['wettkampfzuruecksetzen']) and isset($_SESSION['wk_abwickeln'])){
	unset($_SESSION['wk_abwickeln']);
}
$titel = 'Mitglieder zu Wettkämpfen melden';
$_tmpl->assign('ueberschrift','Wettkampf abwickeln'.(isset($_SESSION['wk_abwickeln']['titel'])?' ('.$_SESSION['wk_abwickeln']['titel'].')':''));
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

# Module laden
$_module = parse_ini_file(PFAD_INCLUDE.'conf/module.ini',true);
if(isset($_module['wkabwickeln'])){
	$_module = $_module['wkabwickeln'];
	foreach($_module as $key => $modul){
		$_wettkampfarten[$key] = $modul;
	}
}
else{
	$_module = false;
}

require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
require_once(PFAD_INCLUDE.'class/wettkaempfe.inc.php');
$wk = new wettkaempfe;
$wk->tmpl = &$_tmpl;
$wk->db = &$_db;
$wk->conf = array('lagen'=>$_lagen,'wkarten'=>$_wkarten,'altersklassen'=>$_altersklassen,'_einst'=>&$_einst,'_gleinst'=>&$_gleinst);

# die Aktionen für die verschiedenen Wettkampftypen
$aktionenfuerwettkampfarten = array(
	'sonstige' => array( # allgemeine Wettkämpfe
		'eigenemeldung',
		'hinzufuegen_pflichtzeiten',
		'hinzufuegen_zeitenexport',
		'hinzufuegen_einzeln',
		'staffeln',
		'staffelmitglieder',
		'staffelzusammensetzung',
		'dsvidlizenzierung_vorhanden',
		'einhaltung_pflichtzeit',
		'uebersicht_mitglieder',
		'uebersicht_wettkaempfe',
		'einstellungen',
		'einstellungen_meldezettel',
		'pdf_meldezettelgenerieren',
		'pdf_leerermeldezettel',
		'ruecklaufzettel',
		'kampfrichter',
		'kontrolllistegenerieren',
		'meldedateigenerieren',
		'pdf_dsvidliste',
		'pdf_teilnehmer',
		'pdf_wettkaempfe',
		'pdf_telefonliste',
		'ergebnisseimportieren',
		'anzahlstartereingeben',
		'wettkampfauswerten',
		'zwischenzeiten-bemerkungen_speichern',
		'ergebnisse'
	)
);

if(!isset($_SESSION['wk_abwickeln'])){
	require_once(PFAD_INCLUDE.'func/wettkaempfe_leseabzuwickelndeein.inc.php');
	wettkaempfe_leseAbzuwickelndeEin();
	$wettkaempfe = $_SESSION['user']['wkabwickeln']['wettkaempfe'];
	if(isset($_POST['wettkampf']) and $_POST['wettkampf'] != 0 and in_array($_POST['wettkampf'],array_keys($wettkaempfe))){
		$_SESSION['wk_abwickeln']['id'] = $_POST['wettkampf'];
		$_SESSION['wk_abwickeln']['dateiname'] = 'wkabwickeln_'.$_POST['wettkampf'].'.ini';
		$query = "SELECT w.verzeichnisid, e.wert, (SELECT COUNT(*) FROM ".DB_PREFIX."abschnitte as a WHERE a.wettkampfid = w.id) as abschnitte
					FROM ".DB_PREFIX."wettkaempfe as w LEFT JOIN ".DB_PREFIX."eigenschaften as e
					ON w.id=e.artid AND e.art='w' AND e.eigenschaft='wettkampfart'
					WHERE id = ".$_POST['wettkampf']."";
		$_db->holeDaten($query);
		if(!is_null($_db->holeWert('verzeichnisid'))){
			$_SESSION['wk_abwickeln']['verzeichnisid'] = $_db->holeWert('verzeichnisid');
		}
		$_SESSION['wk_abwickeln']['abschnitte'] = $_db->holeWert('abschnitte');
		$wkart = $_db->holeWert('wert');
		if(!file_exists(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'])){ # ini-Datei erstellen
			$fh = fopen(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], 'w');
			fclose($fh);
			chmod(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], 0666);
			$einst = array();
			# Wettkampfdaten
			$query = "SELECT id, titel, DATE_FORMAT(datum,'%d.%m.%Y') as datum, 
						  DATE_FORMAT(meldeschluss, '%d.%m.%Y') as meldeschluss_datum, 
						  TIME_FORMAT(meldeschluss, '%H:%i') as meldeschluss_zeit, ort
						FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id'];
			$_db->holeDaten($query);
			$einst['wettkampfdaten'] = $_db->holeZeile();
			$query = "SELECT wert FROM ".DB_PREFIX."eigenschaften 
						WHERE art='w' AND artid=".$_SESSION['wk_abwickeln']['id']." AND eigenschaft='wettkampfart'";
			$_db->holeDaten($query);
			$wettkampfart = $_db->holeWert();
			if($wettkampfart !== false){
				$einst['wettkampfdaten']['wettkampfart'] = $wettkampfart;
				if($wkart == 'dmsj'){
					$einst['dmsj'] = array();
				}
			}
			# Meldedatei
			$query = "SELECT DATE_FORMAT(datum,'%y%m%d') as datum FROM ".DB_PREFIX."abschnitte
						WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." ORDER BY nr DESC LIMIT 1";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() == 1){
				$enddatum = $_db->holeWert('datum');
			}
			else{
				$d = $einst['wettkampfdaten']['datum'];
				$enddatum = substr($d,-2).substr($d,3,2).substr($d,0,2);
			}
			$dateiname = $enddatum.'-'.$einst['wettkampfdaten']['ort'].'-Me-'.TKSWIM_VEREIN;
			$dateiname = strtolower($dateiname);
			$von = array('ü','ö','ä','ß',' ');
			$nach = array('ue','oe','ae','ss','');
			$dateiname = str_replace($von,$nach,$dateiname);
			$dateiname = preg_replace('~[^a-z0-9_.-]+~','-',$dateiname);
			$einst['meldedatei'] = array(
				'dateiname'       => $dateiname,
				'meldeformat'     => 'dsv5',
				'ansprechpartner' => ''			
			);
			# Flags
			$einst['flags'] = array(
				'pflichtzeitengeprueft' => '0',
				'ergebnisseimportiert'  => '-',
				'ausgewertet'           => '-'
			);
			# Kampfrichter
			$einst['kampfrichter'] = array();
			# Meldezettel
			$einst['meldezettel'] = array(
				'abmeldenbei' => $_gleinst['wettkaempfe_abwickeln_meldezettel']['abmeldenbei'],
				'text'        => $_gleinst['wettkaempfe_abwickeln_meldezettel']['texttemplate']
			);
			schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], $einst, true);
			$wktitel = $einst['wettkampfdaten']['titel'];
		}
		else{
			$einst = parse_ini_file(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], true);
		}
		$wktitel = $einst['wettkampfdaten']['titel'];
		list($tag,$monat,$jahr) = explode('.',$einst['wettkampfdaten']['datum']);
		if(isset($einst['wettkampfdaten']['wettkampfart'])){
			$_SESSION['wk_abwickeln']['wettkampfart'] = $einst['wettkampfdaten']['wettkampfart'];
		}
		# Pflichtzeiten?
		$query = "SELECT p.id as pid, p.richtpflicht as rp, p.offiziell as o
					FROM ".DB_PREFIX."eigenschaften as e LEFT JOIN ".DB_PREFIX."pflichtzeiten as p ON e.wert=p.id
					WHERE e.art = 'w' AND e.artid = ".$_SESSION['wk_abwickeln']['id']." AND e.eigenschaft = 'pflichtzeiten'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 0){
			$row = $_db->holeZeile();
			$_SESSION['wk_abwickeln']['pflichtzeiten']    = $row['pid'];
			$_SESSION['wk_abwickeln']['pflichtzeiten_rp'] = $row['rp'];
			$_SESSION['wk_abwickeln']['pflichtzeiten_o']  = $row['o'];
		}
		# Staffeln?
		$query = "SELECT w.id FROM ".DB_PREFIX."wks AS w, ".DB_PREFIX."abschnitte AS a
					WHERE a.id = w.abschnittid AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND
					(SUBSTRING(w.laenge,2,1) = 'x' OR SUBSTRING(w.laenge,3,1) = 'x') AND (wkart = 'e' OR wkart = 'v')";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] > 0){
			$_SESSION['wk_abwickeln']['staffeln'] = 1;
		}
		$_SESSION['wk_abwickeln']['wettkampfdatum'] = $jahr.'-'.$monat.'-'.$tag;
		$_SESSION['wk_abwickeln']['titel'] = $wktitel;
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG);
	}
	if(pruefeRechte('w_bearbeiten') and isset($_GET['wettkaempfewaehlen'])){
		# Wettkämpfe holen
		$query = "SELECT id, CONCAT(titel,' - ',DATE_FORMAT(datum,'%e. %M %Y')) as titel FROM ".DB_PREFIX."wettkaempfe
					WHERE id > 9 AND datum > DATE_SUB(NOW(),INTERVAL 6 MONTH) ORDER BY datum DESC";
		$_db->holeDaten($query);
		$wettkaempfe = $_db->baueArray('titel','id');
		# vorhandene suchen
		if(count($wettkaempfe)>0){
			$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften
						WHERE art = 'w' AND eigenschaft = 'wkabwickeln' AND artid IN (".implode(',',array_keys($wettkaempfe)).")";
			$_db->holeDaten($query);
			$vorhandene = $_db->baueArray('artid','artid');
		}
		else{
			$vorhandene = array();
		}
		if(isset($_POST['speichern'])){
			if(!isset($_POST['bearbeitbare']) or !is_array($_POST['bearbeitbare'])){
				if(count($vorhandene)>0){
					$query = "DELETE FROM ".DB_PREFIX."eigenschaften
								WHERE art = 'w' AND eigenschaft = 'wkabwickeln' AND artid IN (".implode(',',array_keys($vorhandene)).")";
					$_db->fuehreQueryAus($query);
				}
			}
			else{
				$speichern = array();
				foreach($_POST['bearbeitbare'] as $id){
					if(!in_array($id,array_keys($wettkaempfe))){
						continue;
					}
					if(in_array($id, $vorhandene)){
						unset($vorhandene[$id]);
						continue;
					}
					$speichern[] = $id;
				}

				if(count($vorhandene)>0){ # es sind noch vorhandene da die nicht mehr bearbeitet werden sollen -> löschen
					$query = "DELETE FROM ".DB_PREFIX."eigenschaften
								WHERE art = 'w' AND eigenschaft = 'wkabwickeln' AND artid IN (".implode(',',$vorhandene).")";
					$_db->fuehreQueryAus($query);
				}
				if(count($speichern)>0){
					$q = array();

					foreach($speichern as $s){
						$vorhandene[$s] = $s;
						$q[] = "('w', ".$s.", 'wkabwickeln', 1)";
					}
					$query = "INSERT INTO ".DB_PREFIX."eigenschaften (art, artid, eigenschaft, wert) VALUES ".implode(', ',$q)."";
					$_db->fuehreQueryAus($query);
				}
			}
			require_once(PFAD_INCLUDE.'func/wettkaempfe_leseabzuwickelndeein.inc.php');
			wettkaempfe_leseAbzuwickelndeEin(true);

			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG,'die Änderungen wurden gespeichert');
		}
		$_tmpl->assign('vorhandene',$vorhandene);
		$_tmpl->assign('wettkaempfe',$wettkaempfe);
		$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-bearbeitbarewettkaempfewaehlen.inc.html');
	}
	else{
		$_tmpl->assign('wettkaempfe',$_SESSION['user']['wkabwickeln']['wettkaempfe']);
		$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-wettkampfwaehlen.inc.html');
	}
}
else{
	$_wkeinst = parse_ini_file(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],true);
	
	# Wettkampfart
	$_wettkampfart = 'sonstige';

	if(isset($_wkeinst['wettkampfdaten']['wettkampfart']) and in_array($_wkeinst['wettkampfdaten']['wettkampfart'],array_keys($_wettkampfarten))){
		$_wettkampfart = $_wkeinst['wettkampfdaten']['wettkampfart'];
	}

	if(isset($_module[$_wettkampfart])){
		require_once(PFAD_INCLUDE.'module/wkabwickeln_'.$_wettkampfart.'/aktionenliste.inc.php');
	}

	# verfügbare Kategorien
	$kategorien = array(
		'vorbereitung'  => 'Wettkampfvorbereitung',
		'meldeschluss'  => 'Meldeschluss',
		'vorwettkampf'  => 'vor dem Wettkampf',
		'nachwettkampf' => 'nach dem Wettkampf'
	);

	$_meldeschluss_timestamp = false;
	if(!empty($_wkeinst['wettkampfdaten']['meldeschluss_datum'])){
		list($tag,$monat,$jahr) = explode('.',$_wkeinst['wettkampfdaten']['meldeschluss_datum'],3);
		list($stunde,$minute) = explode(':',$_wkeinst['wettkampfdaten']['meldeschluss_zeit'],2);
		$_meldeschluss_timestamp = mktime($stunde,$minute,0,$monat,$tag,$jahr);
	}

	# Flags zum Festlegen der anzuzeigenden Punkte
	$flags = array(
		'meldeschlussvorbei'   => ($_meldeschluss_timestamp!==false and $_meldeschluss_timestamp <= time())?true:false,
		'ergebnisseimportiert' => $_wkeinst['flags']['ergebnisseimportiert']=='+'?true:false,
		'ausgewertet'          => $_wkeinst['flags']['ausgewertet']=='+'?true:false,
		'exportiertezeiten'    => isset($_SESSION['zeitenexport2wkmeldung'])?true:false,
		'pflichtzeiten'        => isset($_SESSION['wk_abwickeln']['pflichtzeiten'])?true:false,
		'staffeln'             => isset($_SESSION['wk_abwickeln']['staffeln'])?true:false,
		'ansprechpartner'      => !empty($_wkeinst['meldedatei']['ansprechpartner']),
		'meldezettel_einst'    => isset($_wkeinst['meldezettel']['ort'])?true:false,
		'ruecklaufzettel'      => (isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']=="1")
	);
	# Aktionen für die Übersichtsseite
	$aktionen = array(
		'anzahlstartereingeben'       => array(
			'titel'     => 'Anzahl der Starter eingeben',
			'recht'     => 'w_abwickeln_ergebnisse',
			'kategorie' => 'nachwettkampf',
			'anzeigen'  => $flags['ergebnisseimportiert'],
			'block'     => 1
		),
		'dsvidlizenzierung_vorhanden' => array(
			'titel'     => 'Prüfen ob die gemeldeten Mitglieder '.($_gleinst['features']['atteste']==1?'DSV-ID und Attest':'eine DSV-ID').' haben und lizenziert sind',
			'recht'     => 'w_abwickeln_meldung',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => 1,
			'block'     => 3
		),
		'eigenemeldung'      => array(
			'titel'     => 'Eigene Meldung bearbeiten',
			'recht'     => 'w_abwickeln_eigenemeldung',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => 1,
			'block'     => 1
		),
		'einhaltung_pflichtzeit'      => array(
			'titel'     => 'Meldungen auf Einhaltung der Pflichtzeiten prüfen',
			'recht'     => 'w_abwickeln_meldung',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => $flags['pflichtzeiten'],
			'block'     => 3
		),
		'einstellungen'               => array(
			'titel'     => 'Einstellungen',
			'recht'     => 'w_abwickeln_meldung',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => 1,
			'block'     => 5
		),
		'einstellungen_meldezettel'  => array(
			'titel'     => 'Meldezettel-Einstellungen',
			'recht'     => 'w_abwickeln_meldezettel',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => 1,
			'block'     => 5
		),
		'ergebnisse'                  => array(
			'titel'     => 'Wettkampfauswertung anzeigen',
			'recht'     => 'w_ergebnisse',
			'kategorie' => 'nachwettkampf',
			'anzeigen'  => $flags['ausgewertet'],
			'block'     => 1,
			'fussnote' => 'die Ergebnisdarstellung befindet sich außerhalb der Wettkampfabwicklung'
		),
		'ergebnisseimportieren'        => array(
			'titel'     => 'Ergebnisse importieren',
			'recht'     => 'w_abwickeln_ergebnisse',
			'kategorie' => 'nachwettkampf',
			'anzeigen'  => !$flags['ergebnisseimportiert'],
			'block'     => 1
		),
		'hinzufuegen_einzeln'         => array(
			'titel'     => 'Mitglieder zur Meldung hinzufügen',
			'recht'     => 'w_abwickeln_mitglhinzufuegen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => !$flags['meldeschlussvorbei'],
			'block'     => 1
		),
		'hinzufuegen_pflichtzeiten'   => array(
			'titel'     => 'Mitglieder nach Pflichtzeiten melden',
			'recht'     => 'w_abwickeln_mitglhinzufuegen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => $flags['pflichtzeiten'] and !$flags['meldeschlussvorbei'],
			'block'     => 1,
			'fussnote'  => 'außerhalb der Wettkampfabwicklung über den Zeitenexport'
		),
		'hinzufuegen_trainingsgruppen' => array(
			'titel'     => 'Mitglieder trainingsgruppenweise melden',
			'recht'     => 'w_abwickeln_mitglhinzufuegen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => !$flags['meldeschlussvorbei'],
			'block'     => 1
		),
		'hinzufuegen_zeitenexport'    => array(
			'titel'     => 'Mitglieder aus Zeitenexport melden',
			'recht'     => 'w_abwickeln_mitglhinzufuegen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => $flags['exportiertezeiten'] and !$flags['meldeschlussvorbei'],
			'block'     => 1
		),
		'kampfrichter'                => array(
			'titel'     => 'Kampfrichter wählen',
			'recht'     => array('w_abwickeln_kampfrichter','w_abwickeln_eigenekarimeldung'),
			'kategorie' => 'meldeschluss',
			'anzeigen'  => 1,
			'block'     => 1
		),
		'kontrolllistegenerieren'     => array(
			'titel'     => 'Kontrollliste generieren',
			'recht'     => 'w_abwickeln_meldung',
			'kategorie' => 'meldeschluss',
			'anzeigen'  => 1,
			'block'     => 2
		),
		'meldedateigenerieren'        => array(
			'titel'     => 'Meldedatei generieren',
			'recht'     => 'w_abwickeln_meldung',
			'kategorie' => 'meldeschluss',
			'anzeigen'  => $flags['ansprechpartner'],
			'block'     => 2
		),
		'pdf_dsvidliste'              => array(
			'titel'     => 'Liste mit DSV-IDs der Teilnehmer',
			'recht'     => 'w_abwickeln_wettkampflisten',
			'kategorie' => 'vorwettkampf',
			'anzeigen'  => $flags['staffeln'],
			'block'     => 1
		),
		'pdf_leerermeldezettel'       => array(
			'titel'     => 'leeren Meldezettel generieren',
			'recht'     => 'w_abwickeln_meldezettel',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => $flags['meldezettel_einst'],
			'block'     => 5
		),
		'pdf_meldezettelgenerieren'   => array(
			'titel'     => 'ausgefüllte Meldezettel generieren',
			'recht'     => 'w_abwickeln_meldezettel',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => $flags['meldezettel_einst'],
			'block'     => 5
		),
		'pdf_teilnehmer'              => array(
			'titel'     => 'Mitgliederliste generieren',
			'recht'     => 'w_abwickeln_wettkampflisten',
			'kategorie' => 'vorwettkampf',
			'anzeigen'  => 1,
			'block'     => 1
		),
		'pdf_telefonliste'            => array(
			'titel'     => 'Telefonnummern-Liste generieren',
			'recht'     => 'w_abwickeln_wettkampflisten',
			'kategorie' => 'vorwettkampf',
			'anzeigen'  => 1,
			'block'     => 1
		),
		'pdf_wettkaempfe'             => array(
			'titel'     => 'Wettkampfliste generieren',
			'recht'     => 'w_abwickeln_wettkampflisten',
			'kategorie' => 'vorwettkampf',
			'anzeigen'  => 1,
			'block'     => 1
		),
		'ruecklaufzettel'             => array(
			'titel'     => 'Rücklaufzettel eingeben',
			'recht'     => 'w_abwickeln_ruecklaufzettel',
			'kategorie' => 'meldeschluss',
			'anzeigen'  => $flags['ruecklaufzettel'],
			'block'     => 1
		),
		'staffelmitglieder'           => array(
			'titel'     => 'Staffelmitglieder wählen',
			'recht'     => 'w_abwickeln_mitglhinzufuegen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => $flags['staffeln'],
			'block'     => 2
		),
		'staffeln'                    => array(
			'titel'     => 'Staffeln melden',
			'recht'     => 'w_abwickeln_mitglhinzufuegen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => $flags['staffeln'] and !$flags['meldeschlussvorbei'],
			'block'     => 2
		),
		'staffelzusammensetzung'      => array(
			'titel'     => 'Staffelzusammensetzungen',
			'recht'     => 'w_abwickeln_mitglhinzufuegen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => $flags['staffeln'],
			'block'     => 2
		),
		'uebersicht_mitglieder'       => array(
			'titel'     => 'Übersicht der Meldungen (sortiert nach Mitgliedern)',
			'recht'     => 'w_abwickeln_anzeigen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => 1,
			'block'     => 4
		),
		'uebersicht_wettkaempfe'      => array(
			'titel'     => 'Übersicht der Meldungen (sortiert nach Wettkämpfen)',
			'recht'     => 'w_abwickeln_anzeigen',
			'kategorie' => 'vorbereitung',
			'anzeigen'  => 1,
			'block'     => 4
		),
		'wettkampfauswerten'          => array(
			'titel'     => 'Wettkampf auswerten',
			'recht'     => 'w_abwickeln_ergebnisse',
			'kategorie' => 'nachwettkampf',
			'anzeigen'  => !$flags['ausgewertet'] and $flags['ergebnisseimportiert'],
			'block'     => 1
		),
		'zwischenzeiten-bemerkungen_speichern'    => array(
			'titel'     => 'Zwischenzeiten und Bemerkungen speichern',
			'recht'     => 'w_abwickeln_bemerkungen',
			'kategorie' => 'nachwettkampf',
			'anzeigen'  => $flags['ergebnisseimportiert'],
			'block'     => 1
		)
	);

	if(isset($_module[$_wettkampfart])){
		require_once(PFAD_INCLUDE.'module/wkabwickeln_'.$_wettkampfart.'/aktionen-flags.inc.php');
	}

	if($flags['pflichtzeiten']){
		$aktionen['hinzufuegen_einzeln']['fussnote'] = 'Achtung, dieser Punkt berücksichtigt keine Pflichtzeiten!';
	}
	# verfuegbare Aktionen
	$_aktionen = $aktionenfuerwettkampfarten[$_wettkampfart];
	$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
	if(!in_array($_GET['aktion'],$_aktionen)){
		$_GET['aktion'] = '';
	}

	if(!empty($_GET['aktion'])){ # Code für die entsprechenden Punkte einbinden
		$a = $aktionen[$_GET['aktion']];
		# prüfen ob Voraussetzungen erfüllt sind
		if(!$a['anzeigen']){
			# passende Fehlermeldung ausgeben
			$fehler = '';
			switch($_GET['aktion']){
			case 'hinzufuegen_einzeln':
			case 'hinzufuegen_trainingsgruppen':
				$fehler .= 'Der Meldeschluss ist bereits vorbei.<br />';
				break;
			case 'anzahlstartereingeben':
			case 'zwischenzeiten-bemerkungen_speichern':
			case 'ergebnisse':
				$fehler .= 'Die Ergebnisse wurde noch nicht importiert<br />';
				break;
			case 'wettkampfauswerten':
				if($flags['ausgewertet'] == '+'){
					$fehler .= 'Der Wettkampf ist schon ausgewertet';
				}
				else{
					$fehler .= 'Die Ergebnisse wurde noch nicht importiert<br />';
				}
				break;
			case 'meldedateigenerieren':
				$url = ROOT.'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=einstellungen';
				$fehler .= 'Die <a href="'.$url.'">Einstellungen</a> sind noch nicht gesetzt worden.<br />';
				break;
			case 'ergebnisseimportieren':
				$fehler .= 'Die Ergebnisse wurde bereits importiert<br />';
				break;
			case 'einhaltung_pflichtzeit':
				$fehler .= 'Für diesen Wettkampf gibt es keine Pflichtzeiten<br />';
				break;
			case 'hinzufuegen_pflichtzeiten':
				if($flags['meldeschlussvorbei']){
					$fehler .= 'Der Meldeschluss ist bereits vorbei.<br />';
				}
				else{
					$fehler .= 'Für diesen Wettkampf gibt es keine Pflichtzeiten<br />';
				}
				break;
			case 'hinzufuegen_zeitenexport':
				if($flags['meldeschlussvorbei']){
					$fehler .= 'Der Meldeschluss ist bereits vorbei.<br />';
				}
				else{
					$fehler .= 'Es wurden keine exportierten Zeiten gefunden.<br />';
				}
				break;
			case 'pdf_leerermeldezettel':
			case 'pdf_meldezettelgenerieren':
				$url = ROOT.'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=einstellungen_meldezettel';
				$fehler .= 'Die <a href="'.$url.'">Einstellungen</a> sind noch nicht gesetzt worden.<br />';
				break;
			case 'staffeln':
				if($flags['meldeschlussvorbei']){
					$fehler .= 'Der Meldeschluss ist bereits vorbei.<br />';
				}
				else{
					$fehler .= 'Für diesen Wettkampf gibt es keine Staffeln<br />';
				}
				break;
			case 'staffelzusammensetzung':
			case 'staffelmitglieder':
				$fehler .= 'Für diesen Wettkampf gibt es keine Staffeln<br />';
				break;
			case 'ruecklaufzettel':
				$fehler .= 'Die Angaben der Rücklaufzettel werden gemäß den Einstellungen von tkswim nicht berücksichtigt.';
				break;
			default:
				if(isset($_module[$_wettkampfart]) and isset($modulfehler[$_GET['aktion']])){
					$fehler .= $modulfehler[$_GET['aktion']];
				}
				else{
					$fehler .= 'Die Aktion kann (noch) nicht durchgeführt werden.<br />';
				}
				break;
			}
			$_tmpl->assign('fehler',$fehler);
		}
		elseif(!pruefeRechte($a['recht'])){
			$_inh .= T_KEINZUGRIFF;
		}
		else{
			if(file_exists(PFAD_INCLUDE.'code/wkabwickeln.'.$_GET['aktion'].'.inc.php')){
				require_once(PFAD_INCLUDE.'code/wkabwickeln.'.$_GET['aktion'].'.inc.php');
			}
			else{
				$meldung = '[tkswim] Im Verzeichnis »'.PFAD_INCLUDE.'code/« fehlt die Datei »wkabwickeln.'.text_format($_GET['aktion'],'html').'.inc.php«';
				trigger_error($meldung, E_USER_ERROR);
			}
		}
	}
	else{ # Übersichtsseite zusammenbauen
		$optionen = array();
		foreach($kategorien as $kat => $titel){
			$optionen[$kat] = array(
				'titel'    => $titel,
				'aktionen' => array()
			);
		}
		foreach($_aktionen as $aktion){
			$tmp = $aktionen[$aktion];
			if(!$tmp['anzeigen'] or !pruefeRechte($tmp['recht'])){
				continue;
			}
			if(!isset($tmp['block'])){
				$tmp['block'] = 1;
			}
			if(!isset($optionen[$tmp['kategorie']]['aktionen'][$tmp['block']])){
				$optionen[$tmp['kategorie']]['aktionen'][$tmp['block']] = array();
			}
			
			$optionen[$tmp['kategorie']]['aktionen'][$tmp['block']][$aktion] = array('titel' => $tmp['titel']);
			if(isset($tmp['fussnote'])){
				$optionen[$tmp['kategorie']]['aktionen'][$tmp['block']][$aktion]['fussnote'] = $tmp['fussnote'];
			}
		}
		foreach($optionen as $kat => $tmp){
			if(count($tmp['aktionen']) < 1){
				unset($optionen[$kat]);
			}
			else{
				ksort($optionen[$kat]['aktionen']);
				
			}
		}
		$_tmpl->assign('optionen', $optionen);
		$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-index.inc.html');
		# Fortschritt in der Abwicklung
		list($tag,$monat,$jahr) = explode('.',$_wkeinst['wettkampfdaten']['datum'],3);
		$wkdatum = mktime(12,0,0,$monat,$tag,$jahr);
		if($_meldeschluss_timestamp !== false){
			if($wkdatum > time()){ # Wettkampf kommt noch
				if($_meldeschluss_timestamp > time()){ # Meldeschluss kommt noch
					if(($_meldeschluss_timestamp-604800) > time()){ # Meldeschluss ist in mehr als einer Woche (604800 = 60*60*24*7)
						$id = 'vorbereitung';
					}
					else{
						$id = 'meldeschluss';
					}
				}
				else{
					$id = 'vorwettkampf';
				}
			}
			else{ # Wettkampf war schon
				$id = 'nachwettkampf';
			}
			$_tmpl->append('css_inline','#'.$id.' { background-color:#DFDFDF; }');
		}
		
		if(isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']=="1"){
			$query = "SELECT COUNT(*) as anz 
						FROM ".DB_PREFIX."meldungen_teilnehmer as mt LEFT JOIN ".DB_PREFIX."meldungen_starts as ms ON mt.id=ms.teilnehmerid
						WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND ms.teilnahme = '0'";
			$_db->holeDaten($query);
			if($_db->holeWert() > 0){
				$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
				$_tmpl->tk_javascriptzuweisen('onready', "\$('.meldeschluss_meldedateigenerieren').tkswim_loeschfrage({ajax:false,frage:'Es gibt noch Starts bei denen noch nicht feststeht ob der Schwimmer teilnimmt. Soll die Meldedatei trotzdem erzeugt werden?'});");

			}
		}
	}
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>