<?php
/*
Wettkampfabwicklung, Aktion: einstellungen_meldezettel
verwendete Templates:
 - 42.meldezettel-einstellungen.inc.html
*/
$_erlaubteflags = array(
	'keinefahrtkaestchen',
	'teilnahmenurjanein'
);
if($_SERVER['REQUEST_METHOD']=='GET'){
	if(isset($_wkeinst['meldezettel']) and isset($_wkeinst['meldezettel']['ort'])){
		$daten = $_wkeinst['meldezettel'];
	}
	else{
		$daten = array();
		# Wettkampftermin(e)
		$query = "SELECT DATE_FORMAT(datum,'%d.%m.%Y') as datum, TIME_FORMAT(MIN(beginn),'%k:%i') as beginn,
					  TIME_FORMAT(DATE_SUB(CONCAT(CURDATE(),' ',MIN(beginn)),INTERVAL 1 HOUR),'%k:%i') as einlass,
					  IF(DATE_FORMAT(datum,'%w')=0,7,DATE_FORMAT(datum,'%w')) as wt, COUNT(datum) as anzahl
					FROM ".DB_PREFIX."abschnitte
					WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." GROUP BY datum ORDER BY ".DB_PREFIX."abschnitte.datum";
		$_db->holeDaten($query);
		$wettkampf_termine = $_db->ergebnis['daten'];
		if(count($wettkampf_termine) == 0){
			trigger_error('[tkswim] Für den Wettkampf sind noch keine Abschnitte angelegt worden', E_USER_ERROR);
		}
		if(count($wettkampf_termine) > 1){
			$tmp_e = array();
			$tmp_b = array();
			$i = 1;
			foreach($wettkampf_termine as $t){
				$tmp_e[] = substr($_wochentage[$t['wt']],0,2).';'.$t['einlass'];
				$tmp_b[] = substr($_wochentage[$t['wt']],0,2).';'.$t['beginn'];
				for($j=0;$j<$t['anzahl'];$j++){
					$daten['treffpunkt_'.$i] = substr($_wochentage[$t['wt']],0,2).'|';
					$i++;
				}
			}
			$daten['einlass'] = implode('|',$tmp_e);
			$daten['beginn'] = implode('|',$tmp_b);
		}
		else{
			$i = 1;
			for($j=0;$j<$wettkampf_termine[0]['anzahl'];$j++){
				$daten['treffpunkt_'.$i] = substr($_wochentage[$wettkampf_termine[0]['wt']],0,2).'|';
				$i++;
			}
			$daten['einlass'] = $wettkampf_termine[0]['einlass'];
			$daten['beginn'] = $wettkampf_termine[0]['beginn'];
		}
		# Rueckgabebis ermittlen (letzes Training vor Meldeschluss)
		$datum = explode('.',$_wkeinst['wettkampfdaten']['meldeschluss_datum']);
		require_once(PFAD_INCLUDE.'class/kalender.inc.php');
		$kal = new kalender();
		$kal->db = &$_db;
		$timestamp = mktime(12,0,0,$datum[1],$datum[0],$datum[2]);
		$wtag = date('w',$timestamp);
		$trainingstag = in_array($wtag,array(0,4,5,6))?4:$wtag;
		$trainingstage = $kal->holeTrainingstage($trainingstag,date('m.Y',strtotime('-2 month',$timestamp)),date('m.Y',$timestamp));
		arsort($trainingstage);
		$daten['rueckgabebis'] = '';
		foreach($trainingstage as $key => $t){
			arsort($t['t']);
			foreach($t['t'] as $tag){
				if(($t['m'] == $datum[1] and $tag <= $datum[0]) or $t['m'] < $datum[1]){
					$daten['rueckgabebis'] = sprintf('%02s',$tag).'.'.$t['m'].'.';
					break 2;
				}
			}
		}
		# Abmelden bei, Rueckmeldung fuer
		$daten['abmeldenbei'] = $_wkeinst['meldezettel']['abmeldenbei'];
		$daten['rueckmeldungfuer'] = 'das '.$_SESSION['wk_abwickeln']['titel'];
		$daten['ort'] = '';
		$daten['flags'] = isset($_wkeinst['meldezettel']['flags'])?$_wkeinst['meldezettel']['flags']:'';
		$daten['text'] = $_wkeinst['meldezettel']['text'];
		if($_wettkampfart == 'dmsj'){
			$daten['text'] = str_replace('[br][br]{br=tab}[br][br]{meldegeldhinweis}','{br=2}[br]{dmsjhinweis}',$daten['text']);
		}
	}
	$_tmpl_daten = array();
	$_tmpl_daten['ort'] = $daten['ort'];
	$_tmpl_daten['text'] = str_replace('[br]',"\n",$daten['text']);
	$_tmpl_daten['rueckgabebis'] = $daten['rueckgabebis'];
	$_tmpl_daten['rueckmeldungfuer'] = $daten['rueckmeldungfuer'];
	$_tmpl_daten['flags'] = array();
	if(isset($daten['flags'])){
		if(strpos($daten['flags'],';')!==false){
			$flags = explode(';',$daten['flags']);
		}
		else{
			$flags = array($daten['flags']);
		}
		foreach($flags as $flag){
			$_tmpl_daten['flags'][$flag] = 1;
		}
	}

	# Einlass, Beginn
	if(strpos($daten['beginn'],'|')===false){
		$tmp_e['art'] = 'einzeln';
		$tmp_e['wert'] = $daten['einlass'];
		$tmp_b['art'] = 'einzeln';
		$tmp_b['wert'] = $daten['beginn'];
	}
	else{
		$dat = explode('|',$daten['einlass']);
		$tmp_e = array('art'=>'mehrere','wert'=>array());
		foreach($dat as $tag){
			list($tmp['wtag'],$tmp['zeit']) = explode(';',$tag);
			$tmp_e['wert'][] = $tmp;
		}

		$dat = explode('|',$daten['beginn']);
		$tmp_b = array('art'=>'mehrere','wert'=>array());
		foreach($dat as $tag){
			list($tmp['wtag'],$tmp['zeit']) = explode(';',$tag);
			$tmp_b['wert'][] = $tmp;
		}
	}
	$_tmpl_daten['einlass'] = $tmp_e;
	$_tmpl_daten['beginn'] = $tmp_b;

	# Abmelden bei
	if(strlen($daten['abmeldenbei']) == 0){
		$_tmpl_daten['abmeldenbei'] = array(array('name'=>'','tel'=>''));
	}
	else{
		if(strpos($daten['abmeldenbei'],'|')===false){
			$dat = array($daten['abmeldenbei']);
		}
		else{
			$dat = explode('|',$daten['abmeldenbei']);
		}
		$_tmpl_daten['abmeldenbei'] = array();
		foreach($dat as $b){
			$tmp = array();
			list($tmp['name'],$tmp['tel']) = explode(';',$b);
			$_tmpl_daten['abmeldenbei'][] = $tmp;
		}
	}

	# Treffpunkte
	$_tmpl_daten['treffpunkt'] = array();
	foreach($daten as $key => $wert){
		if(substr($key,0,10) != 'treffpunkt'){
			continue;
		}
		$tmp = array();
		$tmp['nr'] = substr($key,11);
		list($tmp['wtag'],$tmp['inh']) = explode('|',$wert,2);
		$_tmpl_daten['treffpunkt'][] = $tmp;
	}
	$_tmpl->assign('daten',$_tmpl_daten);
}
else{
	if(isset($_POST['aktionen']['abmeldenbeineu'])){
		$_POST['daten']['abmeldenbei'][] = array('name'=>'','tel'=>'');
	}
	else{
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		# Ort
		$f .= pruefen($_POST['daten']['ort'],'leer','Der Ort fehlt');
		$f .= pruefen($_POST['daten']['ort'],'maxlaenge','Der Ort ist zu lang (max. 150 Zeichen)',150);
		# Rueckmeldungfuer
		$f .= pruefen($_POST['daten']['rueckmeldungfuer'],'leer','Der Text bei "Rückmeldung für ..." fehlt');
		$f .= pruefen($_POST['daten']['rueckmeldungfuer'],'maxlaenge','Der Text bei "Rückmeldung für ..." ist zu lang (max. 150 Zeichen)',150);
		# Einlass
		if($_POST['daten']['einlass']['art'] == 'einzeln'){
			$tmp = &$_POST['daten']['einlass']['wert'];
			$f .= pruefen($tmp,'leer','Die Einlasszeit fehlt');
			$f .= pruefen($tmp,'uhrzeit','Die Einlasszeit ist ungültig');
		}
		else{
			foreach($_POST['daten']['einlass']['wert'] as $key => $e){
				$tmp = &$_POST['daten']['einlass']['wert'][$key];
				$f .= pruefen($tmp['zeit'],'leer','Die Einlasszeit für '.$tmp['wtag'].' fehlt');
				$f .= pruefen($tmp['zeit'],'uhrzeit','Die Einlasszeit für '.$tmp['wtag'].' ist ungültig');
			}
		}
		# Beginn
		if($_POST['daten']['beginn']['art'] == 'einzeln'){
			$tmp = &$_POST['daten']['beginn']['wert'];
			$f .= pruefen($tmp,'leer','Die Anfangszeit fehlt');
			$f .= pruefen($tmp,'uhrzeit','Die Anfangszeit ist ungültig');
		}
		else{
			foreach($_POST['daten']['beginn']['wert'] as $key => $e){
				$tmp = &$_POST['daten']['beginn']['wert'][$key];
				$f .= pruefen($tmp['zeit'],'leer','Die Anfangszeit für '.$tmp['wtag'].' fehlt');
				$f .= pruefen($tmp['zeit'],'uhrzeit','Die Anfangszeit für '.$tmp['wtag'].' ist ungültig');
			}
		}
		# Treffpunkte
		foreach($_POST['daten']['treffpunkt'] as $key => $t){
			$tmp = &$_POST['daten']['treffpunkt'][$key];
			$f .= pruefen($tmp['inh'],'leer','Der Treffpunkt für '.$tmp['wtag'].'/Abschnitt '.$tmp['nr'].' fehlt');
			$f .= pruefen($tmp['zeit'],'maxlaenge','Der Treffpunkt für '.$tmp['wtag'].'/Abschnitt '.$tmp['nr'].' ist zu lang (max. 100 Zeichen)',100);
		}
		# Rueckgabe bis
		$f .= pruefen($_POST['daten']['rueckgabebis'],'leer','Das Datum für Rückgabe bis fehlt');
		$tmp2='';$tmp=&$tmp2;unset($tmp2);# schmutziger Hack, da es sonst weiter unter mit $tmp Probleme gibt
		$tmp = $_POST['daten']['rueckgabebis'].date('Y');
		$f .= pruefen($tmp,'datum','Das Datum für Rückgabe bis ist ungültig');
		$_POST['daten']['rueckgabebis'] = substr($tmp,0,-4);

		# abmelden bei
		foreach($_POST['daten']['abmeldenbei'] as $key => $bei){
			if(isset($bei['loeschen'])){
				unset($_POST['daten']['abmeldenbei'][$key]);
				if(count($_POST['daten']['abmeldenbei']) < 1){
					$f .= 'Es muss mindestens eine Person vorhanden sein, bei der man sich abmelden kann<br />';
					$_POST['daten']['abmeldenbei'][] = array('name'=>'','tel'=>'');
					break;
				}
				continue;
			}
			$tmp = &$_POST['daten']['abmeldenbei'][$key];
			$f .= pruefen($tmp['name'],'leer','Der "Abmelden-bei"-Name fehlt');
			$f .= pruefen($tmp['name'],'maxlaenge','Der "Abmelden-bei"-Name ist zu lang (max 40 Zeichen)',40);
			$f .= pruefen($tmp['tel'],'leer','Die Telefonnummer fehlt');
			$f .= pruefen($tmp['tel'],'maxlaenge','Die Telefonnummer ist zu lang (max 20 Zeichen)',20);
			$f .= pruefen($tmp['tel'],'telefon','Die Telefonnummer ist ungültig',$_gleinst['seitenweit']['standardvorwahl']);
			$tmp['tel'] = str_replace($_gleinst['seitenweit']['standardvorwahl'].'/','',$tmp['tel']);
			$tmp2='';$tmp=&$tmp2;unset($tmp2);# schmutziger Hack, da es sonst weiter unter mit $tmp Probleme gibt
		}
		# Text
		$f .= pruefen($_POST['daten']['text'],'leer','Der Text fehlt');
		$f .= pruefen($_POST['daten']['text'],'maxlaenge','Der Text ist zu lang (max 5000 Zeichen)',5000);
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
		}
		else{
			# Array zum Speichern bauen
			$daten = $_wkeinst['meldezettel'];
			# Einlass/Beginn
			if($_POST['daten']['einlass']['art'] == 'einzeln'){
				$daten['einlass'] = $_POST['daten']['einlass']['wert'];
			}
			else{
				$tmp = array();
				foreach($_POST['daten']['einlass']['wert'] as $wert){
					$tmp[] = $wert['wtag'].';'.$wert['zeit'];
				}
				$daten['einlass'] = implode('|',$tmp);
			}
			if($_POST['daten']['beginn']['art'] == 'einzeln'){
				$daten['beginn'] = $_POST['daten']['beginn']['wert'];
			}
			else{
				$tmp = array();
				foreach($_POST['daten']['beginn']['wert'] as $wert){
					$tmp[] = $wert['wtag'].';'.$wert['zeit'];
				}
				$daten['beginn'] = implode('|',$tmp);
			}
			# Treffpunkt(e)
			foreach($_POST['daten']['treffpunkt'] as $t){
				$daten['treffpunkt_'.$t['nr']] = $t['wtag'].'|'.$t['inh'];
			}
			$daten['rueckgabebis'] = $_POST['daten']['rueckgabebis'];
			$tmp = array();
			# Abmelden bei ...
			foreach($_POST['daten']['abmeldenbei'] as $wert){
				$tmp[] = $wert['name'].';'.$wert['tel'];
			}
			$daten['abmeldenbei'] = implode('|',$tmp);
			# Flags
			if(isset($_POST['daten']['flags'])){
				$tmp = array();
				foreach($_POST['daten']['flags'] as $flag => $wert){
					if(!in_array($flag,$_erlaubteflags)){
						continue;
					}
					$tmp[] = $flag;
				}
				$daten['flags'] = implode(';',$tmp);
			}
			else{
				$daten['flags'] = '';
			}
			# sonstige Felder
			$daten['ort'] = $_POST['daten']['ort'];
			$daten['rueckmeldungfuer'] = $_POST['daten']['rueckmeldungfuer'];
			if(isset($_wkeinst['meldezettel']['generierte'])){
				$daten['generierte'] = $_wkeinst['meldezettel']['generierte'];
			}
			$daten['text'] = preg_replace('/(\015\012)|(\015)|(\012)/','[br]',trim($_POST['daten']['text']));
			# {br} vor und nach {br=tab} entfernen
			$daten['text'] = preg_replace('~(?:(?:\[br\])*?\{br(?:=[^}]+)?\})*((?:\[br\])*)\{br=tab\}((?:\[br\])*)(?:(?:\[br\])*?\{br(?:=[^}]+)?\})*~',"$1{br=tab}$2",$daten['text']);
			# mehrere {br}s hintereinander unterbinden
			$daten['text'] = preg_replace('~((?:\{br(?:=[^}]+)?\}))*~',"$1",$daten['text']);
			$_wkeinst['meldezettel'] = $daten;
			schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=einstellungen_meldezettel','Die Einstellungen wurden gespeichert');
		}
	}
	$_tmpl->assign('daten',$_POST['daten']);
}
# Schlüsselwörter
$sw = $_gleinst['wettkaempfe_abwickeln_meldezettel'];
unset($sw['unterschriftstext'], $sw['freieplaetze'], $sw['mitfahrgelegenheit']);
$_tmpl->assign('schluesselwoerter', $sw);
$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.ui,jquery.tkswim');
$_tmpl->tk_javascriptzuweisen('onready', "\$('.datumwahl').tkswim_datumwahl();");
$_inh .= $_tmpl->fetch('wettkaempfe/42.meldezettel-einstellungen.inc.html');
# EOF
?>