<?php
/*
Wettkampfabwicklung, Aktion: pdf_meldezettelgenerieren
verwendete Templates:
 - 42.meldezettel-mitgliederwaehlen.inc.html
*/
if(!isset($_POST['mids'])){
	$mitglieder = true;
	if($_wettkampfart == 'dmsj'){
		if(!isset($_wkeinst['dmsj'])){
			$mitglieder = false;
		}
		# Mitglieder(-ids) holen
		$tmpmids = array();
		foreach($_wkeinst['dmsj'] as $m){
			$tmp = explode('|',$m);
			$tmpmids = array_merge($tmpmids,$tmp);
		}
		if(count($tmpmids)<1){
			$mitglieder = false;
		}
		else{
			# Mitglieder alphabetisch sortieren
			$query = "SELECT CONCAT(' ',nachname,', ',vorname,' (',YEAR(gebdatum),')') as name, id as mid
						FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$tmpmids).") ORDER BY nachname, vorname";
			$_db->holeDaten($query);
		}
	}
	else{
		$query = "SELECT CONCAT(' ',nachname,', ',vorname,' (',YEAR(gebdatum),')') as name, mid
					FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."mitglieder as m
					WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND mt.mid = m.id
					ORDER BY nachname, vorname";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] < 1){
			$mitglieder = false;
		}
	}

	if(!$mitglieder){
		$_tmpl->assign('fehler','Es wurden noch keine Mitglieder gewählt');
	}
	else{
		$mids = $_db->baueArray('mid','#');
		$_tmplanzeige = $_db->baueArray('name','mid');
		$query = "SELECT trainingsgruppenid as tid, m.id as mid FROM ".DB_PREFIX."mitglieder_trainingsgruppen as mt, ".DB_PREFIX."mitglieder as m
					WHERE mt.mitgliedid = m.id AND m.id IN (".implode(',',$mids).")";
		$_db->holeDaten($query);

		$trgr = array();
		foreach($_db->ergebnis['daten'] as $row){
			if(!isset($trgr[$row['tid']])){
				$trgr[$row['tid']] = array();
			}
			$trgr[$row['tid']][] = $row['mid'];
		}
		require_once(PFAD_INCLUDE.'func/holetrainingsgruppen.inc.php');
		$tmp = holeTrainingsgruppen(true);
		$vorhandene = array_keys($trgr);
		$trainingsgruppen = array();
		foreach($tmp as $key => $wert){
			if(!in_array($key,$vorhandene)){
				continue;
			}
			$trainingsgruppen['g'.$key] = $wert;
		}
		$js_array = 'var trainingsgruppen = {'."\n";
		$gr = array();
		foreach($trgr as $key => $t){
			$gr[] = 'g'.$key.' : ['.implode(',',$t).']';
		}
		$js_array .= '    '.implode(",\n    ", $gr)."\n  }\n";
		$js_array .= '  var gespeicherte = ['.(isset($_wkeinst['meldezettel']['generierte'])?str_replace('|',',',$_wkeinst['meldezettel']['generierte']):'').'];'."\n";
		$groesse = 0;
		if(file_exists(PFAD_INCLUDE.'export/bilder/meldezettel_logo.png')){
			$groesse = filesize(PFAD_INCLUDE.'export/bilder/meldezettel_logo.png')*1.05;
		}
		$groesse += 2700;
		$_tmpl->assign('groesseprodatei', round($groesse/1024));
		$_tmpl->assign('trainingsgruppen',$trainingsgruppen);
		$_tmpl->assign('mitglieder',$_tmplanzeige);
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery');
		$_tmpl->tk_javascriptzuweisen('onready', "$('input[name=\"mids[]\"]').click(groesseberechnen)");
		$_tmpl->tk_javascriptzuweisen('inline', "function groesseberechnen(){
  var anzahl = \$('input[name=\"mids[]\"]:checked').length;
  var groessepromitglied = ".$groesse.";
  if(anzahl == 0){
    \$('#groessenangabe').text(' - zum Generieren der PDF-Datei müssen erst Mitglieder ausgewählt werden.');
  }
  else{
    var groesse = Math.round((groessepromitglied*anzahl)/1024);
    var text = ' - die PDF-Datei wird rund '+groesse+'kB groß sein';
    if(anzahl == 1){
    text += ' (es ist ein Mitglied markiert).';
  }
  else{
    text += ' (es sind '+anzahl+' Mitglieder ausgewählt).';
  }
  \$('#groessenangabe').text(text);
}
}");
		$_tmpl->tk_javascriptzuweisen('inline', "function waehlen(art){
  ".$js_array."
  var e = \$('input[name=\"mids[]\"]');
  switch(art){
  case 'alle':
  case 'keine':
    e.each(function(){
      this.checked = art=='alle';
    });
    break;
  case 'umkehren':
    e.each(function(){
      this.checked = !this.checked;
    });
    break;
  case 'trainingsgruppe':
    var grid = \$('select[name=trgr]').get(0).options[\$('select[name=trgr]').get(0).options.selectedIndex].value;
    e.each(function(){
      for(i=0;trainingsgruppen[grid].length>i;i++){
        if(trainingsgruppen[grid][i]==this.value){
          this.checked = true;
        }
      }
    });
	break;
  case 'generierteweg':
    for(i=0;gespeicherte.length>i;i++){
      e.each(function(){
        if(this.value ==gespeicherte[i]){
          this.checked = false;
        }
      });
    }
    break;
  }
  groesseberechnen();
}");
		$_inh .= $_tmpl->fetch('wettkaempfe/42.meldezettel-mitgliederwaehlen.inc.html');
	}
}
else{
	if(isset($_POST['optionen'])){
		if(isset($_POST['optionen']['zuruecksetzen'])){
			$_wkeinst['meldezettel']['generierte'] = '';
		}
		if(isset($_POST['optionen']['merken'])){
			$_wkeinst['meldezettel']['generierte'] = implode('|',$_POST['mids']);
		}
		schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
	}
	$wk->conf['wochentage'] = $_wochentage;
	$wk->conf['gleinst'] = $_gleinst;
	$wk->generiereMeldezettel($_SESSION['wk_abwickeln']['id'],$_POST['mids']);
}
# EOF
?>