<?php
/*
Wettkampfabwicklung, Aktion: staffeln
verwendete Templates:
 - 42.staffeln-formular.inc.html
*/
$query = "SELECT w.id, wknr, a.nr as abschnnr, w.mw, w.laenge, w.disziplin, w.jahrgang, w.wkart
			FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
			WHERE a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND w.abschnittid = a.id AND
			  (wkart = 'e' OR wkart = 'v') AND (SUBSTRING(laenge,2,1) = 'x' OR SUBSTRING(w.laenge,3,1) = 'x')
			ORDER BY wknr";
$_db->holeDaten($query);
$_staffeln = $_db->baueArray('*','id');
$_tmpl->assign('lagen',$_lagen);
if(!isset($_wkeinst['staffeln'])){
	$_wkeinst['staffeln'] = array();
}
$wks = array();
if(isset($_POST['verarbeiten'])){
	if(isset($_POST['loeschen'])){
		list($key,) = each($_POST['loeschen']);
		list($id,$nr) = explode('_',$key);
		unset($_POST['daten'][$id][$nr]);
	}
	if(isset($_POST['neu'])){
		list($id,) = each($_POST['neu']);
		$_POST['daten'][$id][] = array('zeit'=>'','klasse'=>'');
	}
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	$fz = $fk = $fehler = '';
}
$klassenregex = '^(?:(?:JG\:\d+(-\d+)?)|(?:(?:AK\:(\d+\+?))|[JABCDE]))$';
$klassenregex = '^(?:(?:JG\:\d+(-\d+)?)|(?:AK\:((\d+\+?)|[JABCDE])))$';

function sortiereStaffeln($a, $b){
	if($a['klasse'] == $b['klasse']) {
		if($a['zeit'] == $b['zeit']) {
     	   return 0;
    	}
    	return ($a['zeit'] < $b['zeit']) ? -1 : 1;
    }
    return ($a['klasse'] < $b['klasse']) ? -1 : 1;
}
foreach($_staffeln as $row){
	if(isset($_POST['verarbeiten'])){ # Post-Daten verabeiten
		if(isset($_POST['daten'][$row['id']])){
			foreach($_POST['daten'][$row['id']] as $key => $value){
				# Zeit prüfen
				$fz .= pruefen($_POST['daten'][$row['id']][$key]['zeit'],'schwimmzeit','-','wert');
				# Wertungsklasse prüfen
				if(empty($value['klasse'])){
					continue;
				}
				$value['klasse'] = strtoupper(preg_replace('~\s~','',$value['klasse']));
				if(substr($value['klasse'],2,1) !== ':'){
					$value['klasse'] = substr($value['klasse'],0,2).':'.substr($value['klasse'],2);
				}
				$fk .= pruefen($value['klasse'],'regexpr','-',$klassenregex);
				$_POST['daten'][$row['id']][$key]['klasse'] = $value['klasse'];
			}
			usort($_POST['daten'][$row['id']], 'sortiereStaffeln');
			$row['_zeiten'] = $_POST['daten'][$row['id']];
		}
	}
	else{
		if(isset($_wkeinst['staffeln'][$row['id']])){ # Daten aus ini-Datei holen
			$zeiten = explode(',',$_wkeinst['staffeln'][$row['id']]);
			$staffeln = $row['_zeiten'] = array();
			foreach($zeiten as $zeit){
				$tmp = array();
				if(strpos($zeit,'-') !== false){
					list($tmp['zeit'],$tmp['klasse']) = explode('-', $zeit, 2);
				}
				else{
					$tmp['zeit'] = $zeit;
					$tmp['klasse'] = '';
				}
				$row['_zeiten'][] = $tmp;			
			}
		}
	}
	$wks[$row['id']] = $row;
}

if(!empty($fz)){
	$fehler .= 'Mindestens eine Meldezeit ist ungültig<br />';
}
if(!empty($fk)){
	$fehler .= 'Mindestens eine Wertungsklasse ist ungültig<br />';
}
if(empty($fehler) and isset($_POST['speichern'])){
	foreach($_wkeinst['staffeln'] as $key => $row){
		if(substr($key,0,9) != 'staffeln_'){
			unset($_wkeinst['staffeln'][$key]);
		}
	}
	if(isset($_POST['daten'])){
		$staffeldaten = array();
		foreach($_POST['daten'] as $wkid => $zeiten){
			$tmp = array();
			foreach($zeiten as $row){
				if(empty($row['zeit'])){
					continue;
				}
				$tmp[] = $row['zeit'].(!empty($row['klasse'])?'-'.$row['klasse']:'');
			}
			$staffeldaten[$wkid] = implode(',',$tmp);
		}
		foreach($staffeldaten as $key => $value){
			if(!isset($_staffeln[$key])){
				continue;
			}
			$_wkeinst['staffeln'][$key] = $value;
		}
	}
	schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
	weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=staffeln','Die Staffeln wurden gespeichert');
}
if(!empty($fehler)){
	$_tmpl->assign('fehler',$fehler);
}
$_tmpl->assign('wks',$wks);
$_tmpl->assign('mwx',$_geschlechter);
$_tmpl->assign('_az', $_SESSION['wk_abwickeln']['abschnitte']>1);
$_inh .= $_tmpl->fetch('wettkaempfe/42.staffeln-formular.inc.html');
# EOF
?>