<?php
/*
Wettkampfabwicklung, Aktion: uebersicht_mitglieder
verwendete Templates:
 - 42.uebersicht-mitglieder.inc.html
*/
$bearbeiten = (pruefeRechte('w_abwickeln_mitglhinzufuegen') and !$flags['meldeschlussvorbei']);
if($bearbeiten  and isset($_GET['mitgliedentfernen']) and ctype_digit($_GET['mitgliedentfernen'])){
	$query = "DELETE FROM ".DB_PREFIX."meldungen_teilnehmer WHERE id = ".$_GET['mitgliedentfernen'];
	$_db->fuehreQueryAus($query);
	$query = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$_GET['mitgliedentfernen'];
	$_db->fuehreQueryAus($query);
	weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=uebersicht_mitglieder','Das Mitglied wurde aus der Meldung entfernt');
}

if($bearbeiten and isset($_GET['startentfernen']) and preg_match('~^[0-9]+_[0-9]+$~D',$_GET['startentfernen'])){
	list($tid,$wkid) = explode('_',$_GET['startentfernen']);
	$query = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$tid." AND wkid = ".$wkid."";
	$_db->fuehreQueryAus($query);
	weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=uebersicht_mitglieder','Der Start wurde aus der Meldung entfernt');
}

$query = "SELECT mt.id as tid, mid, CONCAT(m.nachname,', ',m.vorname) as name, m.mw, YEAR(gebdatum) as jg,
			  w.wknr, w.id as wkid, a.nr as abschnnr, w.laenge as laenge, w.disziplin, ms.meldezeit as zeit,
			  mt.teilnahme as t_teilnahme, ms.teilnahme as s_teilnahme
			FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt,
			  ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."mitglieder as m
			WHERE ms.teilnehmerid=mt.id AND w.id = ms.wkid AND w.abschnittid = a.id AND
			  mt.mid = m.id AND mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
			ORDER BY m.nachname, m.vorname, w.wknr";
$_db->holeDaten($query);
if($_db->ergebnis['anzahl'] > 0){
	$daten = array();
	$mid = 0;
	foreach($_db->ergebnis['daten'] as $row){
		if($mid != $row['mid']){
			$daten[$row['mid']] = array(
				'mid'  => $row['mid'],
				'tid'  => $row['tid'],
				'name' => $row['name'],
				'mw'   => $row['mw'],
				'jg'   => $row['jg'],
				'teilnahme' => $row['t_teilnahme'],
				'_wks' => array()
			);
			$mid = $row['mid'];
		}
		$daten[$row['mid']]['_wks'][] = array(
			'wknr'      => $row['wknr'],
			'wkid'      => $row['wkid'],
			'anr'       => $row['abschnnr'],
			'laenge'    => $row['laenge'],
			'disziplin' => $row['disziplin'],
			'zeit'      => is_null($row['zeit'])?'[ohne Zeit]':$row['zeit'],
			'teilnahme' => $row['t_teilnahme'].$row['s_teilnahme']
		);
	}
	$_tmpl->assign('daten',$daten);
}
$teilnahmeklassen = array(
	'+'  => 't_ja',
	'++' => 't_ja',
	'+-' => 't_nein weg',
	'+0' => 't_offen',
	'0'  => 't_offen',
	'00' => 't_offen',
	'-'  => 't_blass',
	'--' => 't_blass',
	'-0' => 't_offen'
);
if(!in_array($_wettkampfart,array('wrcup','vm')) and (isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']=="1")){
	$_tmpl->assign('cl', $teilnahmeklassen);
}
$_tmpl->assign('lagen', $_lagen);
$_tmpl->assign('bearbeiten', $bearbeiten);
$_tmpl->assign('_az', $_SESSION['wk_abwickeln']['abschnitte']>1);
$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({elternelement:'li',keineloeschfrage:true,art:'wkabw_startentfernen'});");
$_tmpl->tk_javascriptzuweisen('onready', "\$('.tloeschen').tkswim_loeschfrage({elternelement:'div',keineloeschfrage:true,art:'wkabw_teilnehmerentfernen'});");
$_inh .= $_tmpl->fetch('wettkaempfe/42.uebersicht-mitglieder.inc.html');
# EOF
?>