<?php
/*
Wettkampfabwicklung, Aktion: uebersicht_wettkaempfe
verwendete Templates:
 - 42.uebersicht-wettkaempfe.inc.html
*/
$bearbeiten = (pruefeRechte('w_abwickeln_mitglhinzufuegen') and !$flags['meldeschlussvorbei']);

if($bearbeiten and isset($_GET['startentfernen']) and preg_match('~^[0-9]+_[0-9]+$~D',$_GET['startentfernen'])){
	list($tid,$wkid) = explode('_',$_GET['startentfernen']);
	$query = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$tid." AND wkid = ".$wkid."";
	$_db->fuehreQueryAus($query);
	weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=uebersicht_wettkaempfe','Der Start wurde aus der Meldung entfernt');
}

$query = "SELECT w.id, abschnittid, wknr, mw, laenge, disziplin, jahrgang, wkart , a.nr as abschnnr
			FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
			WHERE w.abschnittid = a.id AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND SUBSTRING(laenge,2,1) != 'x'
			ORDER BY a.nr, wknr";
$_db->holeDaten($query);
if($_db->ergebnis['anzahl'] > 0){
	$wkdaten = $_db->ergebnis['daten'];
	foreach($wkdaten as $key => $row){
		if($row['wkart'] != 'e' AND $row['wkart'] != 'v'){
			$wkdaten[$key]['_mitglieder'] = array();
			continue;
		}
		$query = "SELECT teilnehmerid as tid, CONCAT(m.nachname,', ',m.vorname) as name, ms.meldezeit as zeit, 
					  IF(meldezeit IS NULL,1,0) zeitnull, ms.teilnahme
					FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt
					WHERE ms.teilnehmerid = mt.id AND mt.mid = m.id AND wkid = ".$row['id']."
					ORDER BY zeitnull, zeit, name";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] < 1){
			$wkdaten[$key]['_mitglieder'] = array();
			continue;
		}
		$wkdaten[$key]['_mitglieder'] = $_db->ergebnis['daten'];
	}
}
else{
	$wkdaten = array();
}
$teilnahmeklassen = array(
	'+' => 't_ja',
	'0' => 't_offen',
	'-' => 't_nein weg'
);
if(!in_array($_wettkampfart,array('wrcup','vm')) and (isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']=="1")){
	$_tmpl->assign('cl', $teilnahmeklassen);
}
$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({elternelement:'li',keineloeschfrage:true,art:'wkabw_startentfernen'});");
$_tmpl->assign('lagen',$_lagen);
$_tmpl->assign('wkdaten',$wkdaten);
$_tmpl->assign('bearbeiten', $bearbeiten);
$_tmpl->assign('_az', $_SESSION['wk_abwickeln']['abschnitte']>1);
$_inh .= $_tmpl->fetch('wettkaempfe/42.uebersicht-wettkaempfe.inc.html');
# EOF
?>