<?php

function smarty_function_navigation($params, &$smarty){

	$br = PHP_EOL;
    $a  = ' class="aktuell"';
    $ak = ' class="aktuellekat"';
    $hk = substr($params['seite'],0,1); # Hauptkategorie
    $uk = $params['seite']; # Unterkategorie

    $ausg = '<div id="nav">'.$br;

	if(isset($_SESSION['adminlogin'])){
    	$ausg .= '<ul>'.$br.' <li><a href="'.ROOT.'/admin.php">Startseite</a></li>'.$br;
        $ausg .= ' <li><a href="'.ROOT.'/update.php">Updates</a></li>'.$br.'</ul>';
    }
    else{
    	$ausg .= '<ul>'.$br;
        $ausg .= ' <li'.($hk==0?$ak:'').'><a href="'.ROOT.'/" accesskey="i">Startseite </a></li>'.$br;
        if(isset($_SESSION['eingelogt']) and $_SESSION['eingelogt'] == 1){
        	# Admin
        	if(prueferechte('a_rechte_anzeigen','a_rechtegruppen_anzeigen', 'a_einstellungen_anzeigen', 'a_zugangsdatenverschicken','a_dbbackup','m_logins','a_neueversion')){
            	$ausg .= ' <li'.($hk==2?$ak:'').'><a href="'.ROOT.'/admin/" accesskey="a">Admin </a>';
                if($hk == 2){
                	$ausg .= $br.'   <ul>'.$br;
                    if(prueferechte('a_rechte_anzeigen')){
                    	$ausg .= '    <li'.($uk==21?$a:'').'><a href="'.ROOT.'/admin/rechte'.TKSWIM_DATEIENDUNG.'">Rechte </a></li>'.$br;
                    }
                    if(prueferechte('a_rechtegruppen_anzeigen')){
                    	$ausg .= '    <li'.($uk==22?$a:'').'><a href="'.ROOT.'/admin/rechtegruppen'.TKSWIM_DATEIENDUNG.'">Rechtegruppen </a></li>'.$br;
                    }
                    if(prueferechte('a_einstellungen_anzeigen')){
                    	$ausg .= '    <li'.($uk==23?$a:'').'><a href="'.ROOT.'/admin/einstellungen'.TKSWIM_DATEIENDUNG.'">Einstellungen </a></li>'.$br;
                    }
                	$ausg .= '   </ul>'.$br;
                }
                $ausg .= ' </li>'.$br;
            }
            # Mitglieder
        	if(prueferechte('m_anzeigen_name','m_kampfrichter_anzeigen','m_familien_anzeigen','m_vorstand_anzeigen')){
            	$ausg .= ' <li'.($hk==1?$ak:'').'><a href="'.ROOT.'/mitglieder/anzeigen'.TKSWIM_DATEIENDUNG.'" accesskey="m">Mitglieder </a>';
                if($hk == 1){
                	$ausg .= $br.'   <ul>'.$br;
                    if(prueferechte('m_anzeigen_name')){
                    	$ausg .= '    <li'.($uk==14?$a:'').'><a href="'.ROOT.'/mitglieder/anzeigen'.TKSWIM_DATEIENDUNG.'">anzeigen </a></li>'.$br;
                    }
                    if(prueferechte('m_anlegen')){
                    	$ausg .= '    <li'.($uk==15?$a:'').'><a href="'.ROOT.'/mitglieder/anlegen'.TKSWIM_DATEIENDUNG.'">anlegen </a></li>'.$br;
                    }
                    if(prueferechte('m_aendern')){
                    	$ausg .= '    <li'.($uk==11?$a:'').'><a href="'.ROOT.'/mitglieder/aendern'.TKSWIM_DATEIENDUNG.'">bearbeiten </a></li>'.$br;
                    }
                    if(prueferechte('m_familien_anzeigen')){
                    	$ausg .= '    <li'.($uk==16?$a:'').'><a href="'.ROOT.'/mitglieder/familien'.TKSWIM_DATEIENDUNG.'">Familien </a></li>'.$br;
                    }
                    if(prueferechte('m_kampfrichter_anzeigen')){
                    	$ausg .= '    <li'.($uk==13?$a:'').'><a href="'.ROOT.'/mitglieder/kampfrichter'.TKSWIM_DATEIENDUNG.'">Kampfrichter </a></li>'.$br;
                    }
                    if(prueferechte('m_vorstand_anzeigen')){
                    	$ausg .= '    <li'.($uk==17?$a:'').'><a href="'.ROOT.'/mitglieder/vorstand'.TKSWIM_DATEIENDUNG.'">Vorstand </a></li>'.$br;
                    }
                    if(prueferechte('m_tools_dsvformulare','m_tools_mitgliederverschmelzen','m_aendern','m_tools_emailsverschicken')){ # können auch mehr Rechte werden
                    	$ausg .= '    <li'.($uk==18?$a:'').'><a href="'.ROOT.'/mitglieder/tools'.TKSWIM_DATEIENDUNG.'">Tools </a></li>'.$br;
                    }
                	$ausg .= '   </ul>'.$br;
                }
                $ausg .= ' </li>'.$br;
            }
            # Training
        	if(prueferechte('tr_*')){
            	$ausg .= ' <li'.($hk==3?$ak:'').'><a href="'.ROOT.'/training/'.(prueferechte('tr_gruppen_anzeigen')?'gruppen'.TKSWIM_DATEIENDUNG:'').'" accesskey="t">Training </a>';
                if($hk == 3){
                	$ausg .= $br.'   <ul>'.$br;
                    if(prueferechte('tr_gruppen_anzeigen')){
                    	$ausg .= '    <li'.($uk==31?$a:'').'><a href="'.ROOT.'/training/gruppen'.TKSWIM_DATEIENDUNG.'">Gruppen </a></li>'.$br;
                    }
                    if(prueferechte('tr_uebungsleiter_anzeigen')){
                    	$ausg .= '    <li'.($uk==32?$a:'').'><a href="'.ROOT.'/training/uebungsleiter'.TKSWIM_DATEIENDUNG.'">Übungsleiter </a></li>'.$br;
                    }
                    if(prueferechte('tr_anwesenheitsliste')){
                    	$ausg .= '    <li'.($uk==33?$a:'').'><a href="'.ROOT.'/training/anwesenheitsliste'.TKSWIM_DATEIENDUNG.'">Anwesenheitsliste </a></li>'.$br;
                    }
                    if(prueferechte('tr_stundennachweis')){
                    	$ausg .= '    <li'.($uk==34?$a:'').'><a href="'.ROOT.'/training/stundennachweis'.TKSWIM_DATEIENDUNG.'">Stundennachweis </a></li>'.$br;
                    }
                	$ausg .= '   </ul>'.$br;
                }
                $ausg .= ' </li>'.$br;
            }
            # Wettkaempfe
        	if(prueferechte('w_*')){
				$wkurl = ($hk!=4 and prueferechte('w_abwickeln_eigenemeldung','w_abwickeln_anzeigen','w_abwickeln_eigenekarimeldung') and $_SESSION['flags']['abzuwickelndewettkaempfe']===true)?'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG:'/wettkaempfe/';
            	$ausg .= ' <li'.($hk==4?$ak:'').'><a href="'.ROOT.$wkurl.'" accesskey="w">Wettkämpfe </a>';
                if($hk == 4){
                	$ausg .= $br.'   <ul>'.$br;
                    if(prueferechte('w_abwickeln_eigenemeldung','w_abwickeln_anzeigen','w_abwickeln_eigenekarimeldung')){
                    	$ausg .= '    <li'.($uk==42?$a:'').'><a href="'.ROOT.'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'">abwickeln </a></li>'.$br;
                    }
                    if(prueferechte('w_lizenzen_anzeigen')){
                    	$ausg .= '    <li'.($uk==46?$a:'').'><a href="'.ROOT.'/wettkaempfe/lizenzen'.TKSWIM_DATEIENDUNG.'">Lizenzen </a></li>'.$br;
                    }
                    if(prueferechte('w_pflichtzeiten')){
                    	$ausg .= '    <li'.($uk==45?$a:'').'><a href="'.ROOT.'/wettkaempfe/pflichtzeiten'.TKSWIM_DATEIENDUNG.'">Pflichtzeiten </a></li>'.$br;
                    }
                	$ausg .= '   </ul>'.$br;
                }
                $ausg .= ' </li>'.$br;
            }
            # Zeiten
        	if(prueferechte('z_*')){
            	$ausg .= ' <li'.($hk==5?$ak:'').'><a href="'.ROOT.'/zeiten/" accesskey="z">Zeiten </a>';
                if($hk == 5){
                	$ausg .= $br.'   <ul>'.$br;
                    if(prueferechte('z_bestenlisten')){
                    	$ausg .= '    <li'.($uk==56?$a:'').'><a href="'.ROOT.'/zeiten/bestenlisten'.TKSWIM_DATEIENDUNG.'">Bestenlisten </a></li>'.$br;
                    }
                    if(prueferechte('z_staffeln_anzeigen')){
                    	$ausg .= '    <li'.($uk==57?$a:'').'><a href="'.ROOT.'/zeiten/staffeln'.TKSWIM_DATEIENDUNG.'">Staffeln </a></li>'.$br;
                    }
                    if(prueferechte('z_eingeben_einzelne','z_eingeben_trainingsgruppe','z_eingeben_protokoll','z_eingeben_staffeln')){
                    	$ausg .= '    <li'.($uk==52?$a:'').'><a href="'.ROOT.'/zeiten/eingeben'.TKSWIM_DATEIENDUNG.'">eingeben </a></li>'.$br;
                    }
                    if(prueferechte('z_importieren')){
                    	$ausg .= '    <li'.($uk==54?$a:'').'><a href="'.ROOT.'/zeiten/importieren'.TKSWIM_DATEIENDUNG.'">importieren </a></li>'.$br;
                    }
                    if(prueferechte('z_lenreferenzzeiten_anzeigen')){
                    	$ausg .= '    <li'.($uk==51?$a:'').'><a href="'.ROOT.'/zeiten/lenreferenzzeiten'.TKSWIM_DATEIENDUNG.'">LEN-Referenzzeiten </a></li>'.$br;
                    }
                	$ausg .= '   </ul>'.$br;
                }
                $ausg .= ' </li>'.$br;
            }
            # Export
        	if(prueferechte('e_*')){
            	$ausg .= ' <li'.($hk==7?$ak:'').'><a href="'.ROOT.'/export/" accesskey="e">Export </a>';
                if($hk == 7){
                	$ausg .= $br.'   <ul>'.$br;
                    if(prueferechte('e_zeiten')){
                        $ausg .= '    <li'.($uk==72?$a:'').'><a href="'.ROOT.'/export/zeiten'.TKSWIM_DATEIENDUNG.'">Zeiten </a></li>'.$br;
                    }
                    if(prueferechte('e_adressen')){
                    	$ausg .= '    <li'.($uk==73?$a:'').'><a href="'.ROOT.'/export/adressen'.TKSWIM_DATEIENDUNG.'">Adressen</a></li>'.$br;
                    }
                    if(prueferechte('e_vereinsrekorde')){
                        $ausg .= '    <li'.($uk==71?$a:'').'><a href="'.ROOT.'/export/vereinsrekorde'.TKSWIM_DATEIENDUNG.'">Vereinsrekorde </a></li>'.$br;
                    }
                	$ausg .= '   </ul>'.$br;
                }
                $ausg .= ' </li>'.$br;
            }
            # Sonstiges
        	if(prueferechte('s_kalender_anzeigen','s_einstellungen','s_dateien')){
            	$ausg .= ' <li'.($hk==6?$ak:'').'><a href="'.ROOT.'/sonstiges/" accesskey="s">Sonstiges </a>';
                if($hk == 6){
                	$ausg .= $br.'   <ul>'.$br;
                    if(prueferechte('s_bilder_anzeigen')){
                    	$ausg .= '    <li'.($uk==65?$a:'').'><a href="'.ROOT.'/sonstiges/bilder'.TKSWIM_DATEIENDUNG.'">Bilder </a></li>'.$br;
                    }
                    if(prueferechte('s_kalender_anzeigen')){
                    	$ausg .= '    <li'.($uk==61?$a:'').'><a href="'.ROOT.'/sonstiges/kalender'.TKSWIM_DATEIENDUNG.'">Kalender </a></li>'.$br;
                    }
                    if(prueferechte('s_dateien')){
                    	$ausg .= '    <li'.($uk==64?$a:'').'><a href="'.ROOT.'/sonstiges/dateien'.TKSWIM_DATEIENDUNG.'">Dateien </a></li>'.$br;
                    }
                    if(prueferechte('s_einstellungen')){
                    	$ausg .= '    <li'.($uk==62?$a:'').'><a href="'.ROOT.'/sonstiges/einstellungen'.TKSWIM_DATEIENDUNG.'">Einstellungen </a></li>'.$br;
                    }
                	$ausg .= '   </ul>'.$br;
                }
                $ausg .= ' </li>'.$br;
            }
            # Tools
        	if(prueferechte('t_*')){
            	$ausg .= ' <li'.($hk==9?$ak:'').'><a href="'.ROOT.'/tools/" accesskey="o">Tools </a>';
                if($hk == 9){
                	$ausg .= $br.'   <ul>'.$br;
                    if(prueferechte('t_berichte')){
                    	$ausg .= '    <li'.($uk==93?$a:'').'><a href="'.ROOT.'/tools/berichte'.TKSWIM_DATEIENDUNG.'">Berichte </a></li>'.$br;
                    }
                    if(prueferechte('t_logdatei_anzeigen')){
                    	$ausg .= '    <li'.($uk==92?$a:'').'><a href="'.ROOT.'/tools/logdatei'.TKSWIM_DATEIENDUNG.'">Logdatei </a></li>'.$br;
                    }
                    if(prueferechte('t_statistik')){
                    	$ausg .= '    <li'.($uk==95?$a:'').'><a href="'.ROOT.'/tools/statistik'.TKSWIM_DATEIENDUNG.'">Statistik </a></li>'.$br;
                    }
                	$ausg .= '   </ul>'.$br;
                }
                $ausg .= ' </li>'.$br;
            }
        }
        $ausg .= '</ul>'.$br;
    }
    $ausg .= '<hr />'.$br;

    if(isset($_SESSION['eingelogt']) and $_SESSION['eingelogt'] == 1){
    	$ausg .= '<p id="logout">'.$br;
    	$ausg .= ' <a href="'.ROOT.'/logout'.TKSWIM_DATEIENDUNG.'">Logout </a>'.$br;
    	$ausg .= '</p>'.$br;
    }
    else{
    	if(($params['seite']=='admin' and PFAD_HTTP=='') or !is_dir(PFAD_HTTP) or !defined('TKSWIM_DATEIENDUNG')){
        	$url = '/admin.php';
        }
        else{
        	$url = '/login'.TKSWIM_DATEIENDUNG.'';
            if(strpos($_SERVER['PHP_SELF'],'login.php') === false){
            	$ps = $_SERVER['PHP_SELF']=='/index.php'?'':$_SERVER['PHP_SELF'];
            	if(TKSWIM_DATEIENDUNG=='.html' and substr($ps,-4)=='.php'){
            		$ps = substr($ps,0,-4).TKSWIM_DATEIENDUNG;
            	}
                $_SESSION['vonseite'] = $ps.(!empty($_SERVER['QUERY_STRING'])?'?'.$_SERVER['QUERY_STRING']:'');
            }
        }
    	$ausg .= '<form action="'.ROOT.$url.'" method="post" class="anmeldeform">'.$br;
        $ausg .= '<fieldset><legend>Login</legend>'.$br;
        if(!empty($_SESSION['fehler'])){
        	$ausg .= '<p class="fehler">'.$_SESSION['fehler'].'</p>'.$br;
        }
        $ausg .= '<p>'.$br;
        $v = isset($_POST['loginanmeldename'])?text_format($_POST['loginanmeldename'],'value'):'';
        $ausg .= ' <label>Benutzername: <input type="text" size="15" name="loginanmeldename"'.$v.' /></label><br />'.$br;
        $ausg .= ' <label>Passwort: <input type="password" size="15" name="loginpasswort" /></label><br />'.$br;
        $ausg .= ' <input type="hidden" name="anmelden" value="1" />'.$br;
        if(ROOT_HTTPS != '-'){
        	$https = (ROOT_HTTP==ROOT);
        	$ausg .= '<a href="'.($https?ROOT_HTTPS:ROOT_HTTP).$url.'">HTTP'.($https?'S':'').'&nbsp;verwenden</a>';
        }
        $ausg .= '<input type="submit" value="Anmelden" />'.$br;
        $ausg .= '<a href="'.ROOT.'/?passwortvergessen">Passwort&nbsp;vergessen?</a>'.$br;
        $ausg .= '</p>'.$br.'</fieldset>'.$br.'</form>'.$br;
	}
    $ausg .= '<div></div>'.$br.'</div>';
    echo $ausg;
}
# EOF
?>