<?php
require_once('../__inc/_start.inc.php');
$_seite = 21;
$erlaubt = pruefeRechte('a_rechte_anzeigen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'bereinigen':
	if(!pruefeRechte('a_rechtegruppen_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Rechte bereinigen');
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Sollen wirklich alle Verknüpfungen Rechte-Rechtegruppe gelöscht werden?');
		$_tmpl->assign('url', '/admin/rechte'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid = '".text_format($_GET['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		weiterleiten('/admin/rechte'.TKSWIM_DATEIENDUNG,'Das Rechte wurde erfolgreich bereinigt');
	}
	break;
case 'aendern':
	if(!pruefeRechte('a_rechte_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Rechte ändern');
	$_dbid = text_format($_GET['id'],'db');
	if(pruefeRechte('a_rechtegruppen_bearbeiten')){
		$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."rechtegruppen WHERE LEFT(bezeichnung,1)!='_' ORDER BY sort";
		$_db->holeDaten($query);
		$_rechtegruppen = $_db->baueArray('bezeichnung','id');
		$_tmpl->assign('_rechtegruppen', $_rechtegruppen);
	}
	if(!isset($_POST['speichern'])){
		$query = "SELECT id, sort, bezeichnung FROM ".DB_PREFIX."rechte WHERE id = '".$_dbid."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Das Recht existiert nicht.');
			break;
		}
		if(pruefeRechte('a_rechtegruppen_bearbeiten')){
			$daten = $_db->holeZeile();
			$query = "SELECT rechtegrid FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid = '".$_dbid."'";
			$_db->holeDaten($query);
			$daten['_rechtegruppen'] = $_db->baueArray('rechtegrid','#');
		}
	}
	else{
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f .= pruefen($_POST['sort'],'leer','Das Feld »sort« darf nicht leer sein');
		$f .= pruefen($_POST['sort'],'zahl','Das Feld »sort« muss eine Zahl enthalten');
		$f .= pruefen($_POST['sort'],'maxlaenge','Das Feld »sort« darf höchstens 6 Ziffern enthalten',6);
		$f .= pruefen($_POST['bezeichnung'],'leer','Die Bezeichnung darf nicht leer sein');
		$f .= pruefen($_POST['bezeichnung'],'minlaenge','Die Bezeichnung muss aus mindestens 2 Zeichen bestehen',2);
		$f .= pruefen($_POST['bezeichnung'],'maxlaenge','Die Bezeichnung darf aus höchstens 100 Zeichen bestehen',100);
		if(empty($f)){
			$query = "UPDATE ".DB_PREFIX."rechte
						SET sort = ".text_format($_POST['sort'],'db').",
							bezeichnung = '".text_format($_POST['bezeichnung'],'db')."'
						WHERE id = '".text_format($_GET['id'],'db')."'";
			$_db->fuehreQueryAus($query);
			if(pruefeRechte('a_rechtegruppen_bearbeiten') and isset($_POST['_rechtegruppen']) and is_array($_POST['_rechtegruppen'])){
				$loeschen = $anlegen = array();
				$query = "SELECT rechtegrid FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid = '".$_dbid."'";
				$_db->holeDaten($query);
				$vorhanden = $_db->baueArray('rechtegrid','#');
				foreach($_rechtegruppen as $rgr => $tmp){
					if(in_array($rgr, $_POST['_rechtegruppen']) and !in_array($rgr, $vorhanden)){
						$anlegen[] = $rgr;
					}										
					if(!in_array($rgr, $_POST['_rechtegruppen']) and in_array($rgr, $vorhanden)){
						$loeschen[] = $rgr;
					}
				}
				if(count($anlegen)>0 and substr($_GET['id'],0,1)!='_'){
					$query = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES (".implode(", '".$_dbid."'), (", $anlegen).",'".$_dbid."')";
					$_db->fuehreQueryAus($query);
				}
				if(count($loeschen)>0){
					$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechtegrid IN (".implode(",",$loeschen).") AND rechteid = '".$_dbid."'";
					$_db->fuehreQueryAus($query);
				}
			}
			elseif(pruefeRechte('a_rechtegruppen_bearbeiten') and !isset($_POST['_rechtegruppen'])){
				$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid = '".$_dbid."'";
				$_db->fuehreQueryAus($query);
			}
			weiterleiten('/admin/rechte'.TKSWIM_DATEIENDUNG,'Das Recht »'.text_format($_POST['bezeichnung'],'html').'« wurde geändert');
		}
		else{
			$daten = $_POST;
			$_tmpl->assign('fehler',$f);
		}
	}
	$_tmpl->assign('daten',$daten);	
	$_inh .= $_tmpl->fetch('admin/21.rechte-formular.inc.html');
	break;

default:
	$query = "SELECT id FROM ".DB_PREFIX."rechte";
	$_db->holeDaten($query);
	$anzahl = $_db->ergebnis['anzahl'];
	$s = 1;
	$proseite = $_einst['globaleeinstellungen']['blaetternseiten']!=0?$_einst['globaleeinstellungen']['blaetternseiten']:25;
	if(isset($_GET['seite']) and $_GET['seite'] == 'alle'){
		$s = 'alle';
	}
	elseif(isset($_GET['seite']) and ctype_digit($_GET['seite']) and $_GET['seite']!=0){
		if($proseite*($_GET['seite']-1) > $anzahl){
			$s = ceil($anzahl/$proseite);
		}
		else{
			$s = (int)$_GET['seite'];
		}
	}
	$query = "SELECT r.id, r.sort, r.bezeichnung, count(rgr.rechteid) AS anzahl
				FROM ".DB_PREFIX."rechte AS r LEFT JOIN ".DB_PREFIX."rechtegruppen_rechte AS rgr ON r.id = rgr.rechteid
				GROUP BY r.id ORDER BY sort ".($s!='alle'?'LIMIT '.((($s-1)*$proseite).",".$proseite):'')."";
	$_db->holeDaten($query);
	$_tmpl->assign('ueberschrift','Rechteübersicht');
	$_tmpl->assign('blaettern',array('anzahl'=>$anzahl,'seite'=>$s,'proseite'=>$proseite));
	$_tmpl->assign('rechte',$_db->ergebnis['daten']);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.bereinigen').tkswim_loeschfrage({frage:'Sollen wirklich alle Verknüpfungen zu Rechtegruppen gelöscht werden?',ajax:false});");
	$_inh .= $_tmpl->fetch('admin/21.rechte-uebersicht.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>