<?php
require_once('../__inc/_start.inc.php');
$_seite = 73;
$erlaubt = pruefeRechte('e_adressen');
$_tmpl->assign('ueberschrift','Export - Adressen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
default:
	if(!pruefeRechte('e_adressen')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$mitgliederarten = array(
		'trainierende'      => 'trainierende Mitglieder',
		'nichtausgetretene' => 'nicht ausgetretene Mitglieder',
		'ausgetretene'      => 'ausgetretene Mitglieder',
		'alle'              => 'alle Mitglieder'
	);
	if(!isset($_POST['generieren'])){
		$_tmpl->assign('telefonarten',$_telefonarten);
		$_tmpl->assign('mitgliederarten',$mitgliederarten);
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "$('#f_name').tkswim_statuscheckbox({aktivieren:['select[name=\"optionen[name][reihenfolge]\"]','input[name=\"optionen[name][langkurz]\"]']});");
		$_tmpl->tk_javascriptzuweisen('onready', "$('#f_gebdatum').tkswim_statuscheckbox({aktivieren:['select[name=\"optionen[gebdatum][format]\"]']});");
		$_tmpl->tk_javascriptzuweisen('onready', "$('#f_trainingsgruppen').tkswim_statuscheckbox({aktivieren:['input[name=\"optionen[trainingsgruppen][format]\"]']});");	
		$_tmpl->tk_javascriptzuweisen('onready', "$('#f_telefon').tkswim_statuscheckbox({aktivieren:['select[name=\"optionen[telefon][welche]\"]','select[name=\"optionen[telefon][art]\"]']});");
		$_tmpl->tk_javascriptzuweisen('onready', "$('#s_pdferzeugen').tkswim_statuscheckbox({einblenden:['#h_pdfoptionen']});");
		$_tmpl->tk_javascriptzuweisen('onready', "$('#s_nurjahrgang').tkswim_statuscheckbox({aktivieren:['input[name=\"optionen[nurjahrgang][jahrgang]\"]']});");
		$_tmpl->tk_javascriptzuweisen('onready', "$('#o_pdf_seitenzahlen').tkswim_statuscheckbox({aktivieren:['input[name=\"optionen[pdf][seitenzahlformat]\"]']});");
		$_inh .= $_tmpl->fetch('export/73.adressen.inc.html');
		break;
	}
	$_eapf = isset($_POST['sonstiges']['eineadresseprofamilie']);
	$_dbspalten = $titel = array();
	$_dbspalten[] = 'id';
	if(isset($_POST['felder']['id'])){
		$titel[] = 'ID';
	}
	$langkurz = 'kurz';
	if(isset($_POST['felder']['name'])){
		$langkurz = (isset($_POST['optionen']['name']['langkurz']) and $_POST['optionen']['name']['langkurz']=='lang')?'lang':'kurz';
		switch($_POST['optionen']['name']['reihenfolge']){
			case 'vorname_nachname':
				$_dbspalten[] = "CONCAT(vorname,' ',nachname) as name";
				$titel[] = 'Name';
				break;
			case 'nachname_vorname':
				$_dbspalten[] = "CONCAT(nachname,', ',vorname) as name";
				$titel[] = 'Name';
				break;
			default:
				$_dbspalten[] = 'nachname';
				$_dbspalten[] = 'vorname';
				$titel[] = 'Name';
				$titel[] = 'Vorname';
				break;
		}
	}
	if(isset($_POST['felder']['mw'])){
		$_dbspalten[] = 'mw';
		$titel[] = 'mw';
	}
	if(isset($_POST['felder']['gebdatum'])){
		if($_POST['optionen']['gebdatum']['format'] == 'yyyy-mm-dd'){
			$_dbspalten[] = 'gebdatum';
		}
		else{
			$_dbspalten[] = "DATE_FORMAT(gebdatum,'%d.%m.%Y') as gebdatum";
		}
		$titel[] = 'Gebdatum';
	}
	if(isset($_POST['felder']['strasse'])){
		if(isset($_POST['sonstiges']['strhausnrgetrennt'])){
			$_dbspalten[] = "strasse";
			$_dbspalten[] = "hausnr";
			$titel[] = 'Straße';
			$titel[] = 'Hausnr';
		}
		else{
			$_dbspalten[] = "CONCAT(strasse,' ',hausnr) as str";
			$titel[] = 'Straße';
		}
	}
	if(isset($_POST['felder']['ort'])){
		if(isset($_POST['sonstiges']['ortplzgetrennt'])){
			$_dbspalten[] = "plz";
			$_dbspalten[] = "ort";
			$titel[] = 'PLZ';
			$titel[] = 'Ort';
		}
		else{
			$_dbspalten[] = "CONCAT(plz,' ',ort) as ort";
			$titel[] = 'Ort';
		}
	}
	if(isset($_POST['felder']['eingetreten'])){
		$_dbspalten[] = "DATE_FORMAT(eingetreten,'%d.%m.%Y') as eingetreten";
		$titel[] = 'eingetreten';
	}
	if(isset($_POST['felder']['ausgetreten']) or $_eapf){
		$_dbspalten[] = 'ausgetreten';
		if(isset($_POST['felder']['ausgetreten'])){
			$titel[] = 'ausgetreten';
		}
	}
	if(isset($_POST['felder']['email'])){
		$_dbspalten[] = 'email';
		$titel[] = 'E-Mail';
	}
	if(isset($_POST['felder']['dsvid'])){
		$_dbspalten[] = 'dsvid';
		$titel[] = 'DSV-ID';
	}
	if(isset($_POST['felder']['trainingsgruppen'])){
		$_dbspalten[] = "'' as trainingsgruppen";
		$titel[] = 'Trainingsgruppen';
	}
	if($_eapf){
		$_dbspalten[] = 'familienid';
		$_dbspalten[] = "CONCAT(strasse,' ',hausnr,', ',plz,' ',ort) as adresse";
		$_dbspalten[] = 'vorname as vname';
		$_dbspalten[] = 'gebdatum as sortgebdatum';
		$_dbspalten[] = 'eingetreten as sorteingetreten';
	}
	if(isset($_POST['felder']['telefon'])){
		$titel[] = 'Telefon';
	}

	$query = "SELECT ".implode(',',$_dbspalten)." FROM ".DB_PREFIX."mitglieder";
	if(isset($_POST['sonstiges']['welchemitglieder']) and in_array($_POST['sonstiges']['welchemitglieder'], array_keys($mitgliederarten))){
		$welchemitglieder = $_POST['sonstiges']['welchemitglieder'];
	}
	else{
		$welchemitglieder = 'nichtausgetretene';
	}
	$where = array();
	switch($welchemitglieder){
	case 'trainierende':
		$query2 = "SELECT DISTINCT mitgliedid FROM ".DB_PREFIX."mitglieder_trainingsgruppen ORDER BY mitgliedid";
		$_db->holeDaten($query2);
		$mids = $_db->baueArray('mitgliedid','#');
		if(count($mids) > 0){
			$where[] = 'id IN ('.implode(', ', $mids).')';
		}
		break;
	case 'nichtausgetretene':
		$where[] = 'ausgetreten IS NULL';
		break;
	case 'ausgetretene':
		$where[] = 'ausgetreten IS NOT NULL';
		break;
	case 'alle':
		# hier wird einfach ein Query ohne WHERE abgefeuert
		break;
	}

	if(isset($_POST['sonstiges']['nurjahrgang']) and isset($_POST['optionen']['nurjahrgang']['jahrgang']) and preg_match('~^\d{4}(\+|-(\d{4})?)?$~', $_POST['optionen']['nurjahrgang']['jahrgang'])){
		$wert = $_POST['optionen']['nurjahrgang']['jahrgang'];
		if(strlen($wert) == 4){
			$where[] = 'YEAR(gebdatum) = '.$wert;
		}
		elseif(strlen($wert) == 5){
			$where[] = 'YEAR(gebdatum) '.($wert[4]=='+'?'<=':'>=').' '.substr($wert,0,-1);
		}
		else{
			$where[] = 'YEAR(gebdatum) BETWEEN '.substr($wert,0,4).' AND '.substr($wert,5);
		}	
	}

	if(count($where)>0){
		$query .= ' WHERE '.implode(' AND ', $where);	
	}
	
	$query .= " ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$ergebnis = $_db->baueArray('*', 'id');
	$datenarray = array();
	$familien = array();

	if($langkurz=='lang'){
		$query = "SELECT artid, wert FROM ".DB_PREFIX."eigenschaften WHERE eigenschaft = 'langname' AND art='m'";
		$_db->holeDaten($query);
		$langnamen = $_db->baueArray('wert', 'artid');
	}
	if(isset($_POST['felder']['trainingsgruppen'])){
		$trainingsgruppen = array();
		$query = "SELECT id,DATE_FORMAT(ADDDATE('2009-10-11', INTERVAL wochentag DAY), '%W') as w,
					  DATE_FORMAT(ADDDATE('2009-10-11', INTERVAL wochentag DAY), '%a') as z, TIME_FORMAT(anfangszeit, '%H:%i') as a,
					  TIME_FORMAT(endzeit, '%H:%i') as e, kommentar as k
					FROM ".DB_PREFIX."trainingsgruppen ORDER BY wochentag, anfangszeit, kommentar";
		$_db->holeDaten($query);
		$trainingsgruppen = $_db->baueArray('*','id');

	}

	foreach($ergebnis as $key => $row){
		if(isset($_POST['felder']['telefon'])){
			$telefon = false;
			if($_POST['optionen']['telefon']['welche'] == 'alle'){
				$query = "SELECT CONCAT(vorwahl,'/',nummer) as nr FROM ".DB_PREFIX."telefon
							WHERE mitgliedid = ".$row['id']." ORDER BY telefonart";
				$telefon = true;
			}
			elseif(in_array($_POST['optionen']['telefon']['art'],array_keys($_telefonarten))){
				$query = "SELECT CONCAT(vorwahl,'/',nummer) as nr FROM ".DB_PREFIX."telefon
							WHERE mitgliedid = ".$row['id']." AND
							telefonart = ".$_POST['optionen']['telefon']['art']."";
				$telefon = true;
			}
			if($telefon){
				$_db->holeDaten($query,E_USER_ERROR,'row');
				$tel = $_db->baueArray('0');
				$row['tel'] = implode(', ',$tel);
			}
		}
		if(isset($_POST['felder']['trainingsgruppen']) and $welchemitglieder != 'ausgetretene'){
			$query = "SELECT trainingsgruppenid FROM ".DB_PREFIX."mitglieder_trainingsgruppen WHERE mitgliedid = ".$key;
			$_db->holeDaten($query);
			if($_db->holeAnzahl()>0){
				$gruppenmitglied = $_db->baueArray('trainingsgruppenid','trainingsgruppenid');

				$gruppen = array();
				foreach($trainingsgruppen as $id => $rowtr){
					if(!in_array($id, $gruppenmitglied)){
						continue;
					}
					$t = str_replace('%k',$rowtr['k'],$_POST['optionen']['trainingsgruppen']['format']);
					$t = str_replace('%w',$rowtr['w'],$t);
					$t = str_replace('%z',$rowtr['z'],$t);
					$t = str_replace('%a',$rowtr['a'],$t);
					$gruppen[] = str_replace('%e',$rowtr['e'],$t);
				}
				$row['trainingsgruppen'] = implode(', ', $gruppen);
			}
		}
		if($langkurz == 'lang' and isset($langnamen[$row['id']])){
			switch($_POST['optionen']['name']['reihenfolge']){
			case 'vorname_nachname':
				$row['name'] = str_replace('|',' ',$langnamen[$row['id']]);
				break;
			case 'nachname_vorname':
				$tmp = explode('|',$langnamen[$row['id']],2);
				$row['name'] = $tmp[1].', '.$tmp[0];
				break;
			default:
				$tmp = explode('|',$langnamen[$row['id']],2);
				$row['nachname'] = $tmp[1];
				$row['vorname'] = $tmp[0];
				break;
			}
		}
		if(isset($row['eingetreten']) and $row['eingetreten'] == '00.00.0000'){
			$row['eingetreten'] = '';
		}
		$row = array_map('trim',$row);

		if($_eapf and $row['familienid'] != 0){
			if(!isset($familien[$row['familienid']])){
				$familien[$row['familienid']] = array();
			}
			$familien[$row['familienid']][$row['id']] = array(
				'adresse' => $row['adresse'],
				'eingetreten' => $row['sorteingetreten'],
				'ausgetreten' => $row['ausgetreten'],
				'gebdatum'    => $row['sortgebdatum'],
				'vorname' => $row['vname'],
				'mid' => $row['id']
			);
		}

		if(!in_array('ID',$titel)){
			unset($row['id']);
		}

		$ergebnis[$key] = $row;
	}

	# ggf. überflüssige Familienmitglieder entfernen
	if($_eapf){
		function eineadressensort($a, $b){
			# Sortierreihenfolge
			#  ausgetreten, eingetreten, gebdatum, vorname
			if(!is_null($a['ausgetreten']) and is_null($b['ausgetreten'])){
				return -1;
			}
			elseif(is_null($a['ausgetreten']) and !is_null($b['ausgetreten'])){
				return 1;
			}
			else{
				if($a['eingetreten'] == $b['eingetreten']){
					if($a['gebdatum'] == $b['gebdatum']){
						return $a['vorname'] <= $b['vorname'] ? -1 : 1;
					}
					else{
						return $a['gebdatum'] < $b['gebdatum'] ? -1 : 1;
					}
				}
				else{
					return $a['eingetreten'] < $b['eingetreten'] ? -1 : 1;
				}
			}
		}

		foreach($familien as $fid => $mitglieder){
			$fam = array();
			# Familienmitglieder nach Adresse gruppieren
			foreach($mitglieder as $mid => $mitglied){
				$key = false;
				foreach($fam as $k => $f){
					if($f['adresse'] == $mitglied['adresse']){
						$key = $k;
						break;
					}
				}
				if($key === false){
					$fam[] = array(
						'adresse' => $mitglied['adresse'],
						'mitglieder' => array($mid)
					);
				}
				else{
					$fam[$key]['mitglieder'][] = $mid;
				}
			}
			# ein Mitglied pro Familie raussuchen und den Rest aus dem Ergebnis-Array entfernen
			foreach($fam as $familie){
				$mitgl = array();
				foreach($familie['mitglieder'] as $mid){
					$mitgl[] = $mitglieder[$mid];
				}
				uasort($mitgl, 'eineadressensort');
				$empfaenger = array_shift($mitgl);

				if(count($mitgl)>0){
					$weiterenamen = array();
					foreach($mitgl as $row){
						$weiterenamen[] = $row['vorname'];
						unset($ergebnis[$row['mid']]);
					}
					sort($weiterenamen);
					$ergebnis[$empfaenger['mid']]['weiterenamen'] = implode(', ', $weiterenamen);
				}
			}
		}
		# noch überflüssige Spalten löschen
		foreach($ergebnis as $key => $row){
			unset($row['vname'], $row['sortgebdatum'], $row['sorteingetreten'], $row['familienid'], $row['adresse']);
			if(!isset($_POST['felder']['ausgetreten'])){
				unset($row['ausgetreten']);
			}
			if(!isset($row['weiterenamen'])){
				$row['weiterenamen'] = '';
			}

			$ergebnis[$key] = $row;
		}
		$titel[] = 'weitere Namen';
	}

	if(isset($_POST['sonstiges']) and isset($_POST['sonstiges']['pdferzeugen'])){
		require_once(PFAD_INCLUDE.'class/pdf.inc.php');
		$pdf = new tkpdf(10, 'quer');
		if(isset($_POST['optionen']['pdf']['seitenzahlen'])){
			$format = substr($_POST['optionen']['pdf']['seitenzahlformat'],0,40);
			$format = str_replace(array('{x}','{y}'),array('{PAGENUM}','{TOTALPAGENUM}'),$format);
			$pdf->tkseitennummern($format);
		}
		$pdf->tkseitentitel($_POST['optionen']['pdf']['ueberschrift'],12,350,560);
		if(isset($_POST['optionen']['pdf']['datum'])){
			$pdf->tkseitentitel(date('d.m.Y'),0,80,20);
		}
		$optionen = array(
			'fontSize' => $pdf->tk_schriftgroesse,
			'titelFontSize' => $pdf->tk_schriftgroesse,
			'xPos' => 80,
			'xOrientation' => 'right',
			'shaded' => 0,
			'showLines' => 2,
			'colGap' => 3,
			'rowGap' => 1,
			'maxWidth' => 750,
			'innerLineThickness' => 0.5,
			'outerLineThickness' => 1.5
		);
		$tmp = $ergebnis;
		$erster = array_shift($tmp);
		unset($tmp);
		$spalten = array_combine(array_keys($erster),$titel);
		foreach($spalten as $key => $value){
			$spalten[$key] = '<b>'.$value.'</b>';
		}
		$pdf->ezTable($ergebnis,$spalten,'',$optionen);
		$pdf->tk_autor = $_SESSION['user']['realname'];
		$pdf->tk_titel = 'Adressliste '.TKSWIM_VEREIN.(TKSWIM_VEREINSART=='abteilung'?', Schwimmabteilung':'');
		$pdf->tkstream('adressliste_'.date('Y-m-d_H-i').'.pdf');
	}
	else{
		$tr = $_einst['dateisystem']['csvdateitrenner']=='tab'?"\t": $_einst['dateisystem']['csvdateitrenner'];
		$daten = '"'.implode('"'.$tr.'"',$titel).'"'."\n";
		foreach($ergebnis as $row){
			$daten .= '"'.implode('"'.$tr.'"',$row)."\"\n";
		}
		header('Content-Type: text/comma-separated-values');
		header('Content-Length: '.strlen($daten));
		header('Content-Disposition: attachment; filename="adressliste_'.date('Y-m-d_H-i').'.csv"');
		echo $daten;
		exit;
	}
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>