<?php
require_once('../__inc/_start.inc.php');
$_seite = 71;
$erlaubt = pruefeRechte('e_vereinsrekorde');
$_tmpl->assign('ueberschrift','Export - Vereinsrekorde');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

if(!defined('BR')){
	define('BR',PHP_EOL);
}

$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'vjr_lenex':
	$query = "SELECT z.id as zid, m.vorname, m.nachname, m.mw, CONCAT(YEAR(m.gebdatum),'-01-01') as mdatum, m.dsvid,
				  z.zeit, z.streckenlaenge, z.disziplin, w.ort, w.titel, DATE_FORMAT(z.datum, '%Y-%m-%d') as zdatum,
				  IF(YEAR(z.datum)-YEAR(gebdatum)>=20,CONCAT('ak',FLOOR((YEAR(z.datum)-YEAR(gebdatum))/5)*5),YEAR(z.datum)-YEAR(gebdatum)) as ak,
				  IF(YEAR(z.datum)-YEAR(gebdatum)>=20,FLOOR((YEAR(z.datum)-YEAR(gebdatum))/5)*5,YEAR(z.datum)-YEAR(gebdatum)) as sortak
				FROM ((".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id)
				  LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id)
				  LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid=w.id
				WHERE zr.art='aVJR' ORDER BY sortak, disziplin, streckenlaenge";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()<1){
		$_tmpl->assign('fehler','Es wurden keine Vereinsjahrgangsrekorde gefunden');
		break;
	}
	$zeiten = $_db->baueArray('*','#');

	$_lagen_en = array(
		1 => 'FREE',
		2 => 'BREAST',
		3 => 'BACK',
		4 => 'FLY',
		5 => 'MEDLEY'
	);

	$vjr = array();
	$neuesterrekord = array();
	foreach($zeiten as $row){
		if(!isset($vjr[$row['ak']])){
			$vjr[$row['ak']] = array('m'=>'','w'=>'');
			$neuesterrekord[$row['ak']] = array('m'=>'0000-00-00','w'=>'0000-00-00');
		}
		if($row['zdatum'] > $neuesterrekord[$row['ak']][$row['mw']]){
			$neuesterrekord[$row['ak']][$row['mw']] = $row['zdatum'];
		}
		$vjr[$row['ak']][$row['mw']] .= '    <RECORD swimtime="00:'.text_format($row['zeit'],'schwimmzeit').'">'.BR;
		$vjr[$row['ak']][$row['mw']] .= '     <SWIMSTYLE relaycount="1" distance="'.$row['streckenlaenge'].'" stroke="'.$_lagen_en[$row['disziplin']].'" />'.BR;
		$vjr[$row['ak']][$row['mw']] .= '     <MEETINFO city="'.text_format($row['ort'],'xml').'" date="'.$row['zdatum'].'" name="'.text_format($row['titel'],'xml').'" nation="GER" />'.BR;
		$vjr[$row['ak']][$row['mw']] .= '     <ATHLETE birthdate="'.$row['mdatum'].'" firstname="'.text_format($row['vorname'], 'xml').'" gender="'.($row['mw']=='m'?'M':'F').'" lastname="'.text_format($row['nachname'], 'xml').'"'.(!is_null($row['dsvid'])?' passport="'.$row['dsvid'].'"':'').' />'.BR;
		$vjr[$row['ak']][$row['mw']] .= '    </RECORD>'.BR;
	}

	$inhalt = '<?xml version="1.0" encoding="UTF-8"?>'.BR;
	$inhalt .= '<LENEX version="2.0">'.BR;
	$inhalt .= ' <CONSTRUCTOR name="tkswim" version="'.TKSWIM_VERSION.'">'.BR;
	$inhalt .= '  <CONTACT name="Tobias Kloth" country="GER" email="" internet="http://tkswim.de/" />'.BR;
	$inhalt .= ' </CONSTRUCTOR>'.BR;
	$inhalt .= ' <RECORDLISTS>'.BR;
	foreach($vjr as $ak => $rekorde){
		$name = '';
		if(substr($ak,0,2) == 'ak'){
			$name = strtoupper($ak);
			if($ak == 'ak95'){
				$minalter = 95;
				$maxalter = -1;
			}
			else{
				list($minalter,,,,$maxalter) = explode(',',$_altersklassen[$ak]);
			}
		}
		else{
			$minalter = $maxalter = $ak;
		}
		$inhalt .= '  <RECORDLIST course="OPEN" gender="M" name="Vereinsjahrgangsrekorde" updated="'.$neuesterrekord[$ak]['m'].'">'.BR;
		$inhalt .= '   <AGEGROUP agemin="'.$minalter.'" agemax="'.$maxalter.'"'.(!empty($name)?' name="'.$name.'"':'').' />'.BR;
		$inhalt .= '   <RECORDS>'.BR;
		$inhalt .= $rekorde['m'];
		$inhalt .= '   </RECORDS>'.BR;
		$inhalt .= '  </RECORDLIST>'.BR;
		$inhalt .= '  <RECORDLIST course="OPEN" gender="F" name="Vereinsjahrgangsrekorde" updated="'.$neuesterrekord[$ak]['w'].'">'.BR;
		$inhalt .= '   <AGEGROUP agemin="'.$minalter.'" agemax="'.$maxalter.'"'.(!empty($name)?' name="'.$name.'"':'').' />'.BR;
		$inhalt .= '   <RECORDS>'.BR;
		$inhalt .= $rekorde['w'];
		$inhalt .= '   </RECORDS>'.BR;
		$inhalt .= '  </RECORDLIST>'.BR;
	}
	$inhalt .= ' </RECORDLISTS>'.BR;
	$inhalt .= '</LENEX>'.BR;

	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($inhalt, 'vereinsjahrgangsrekorde.lef');
	$zipinh = $zip->gebeDateiAus('vereinsjahrgangsrekorde.lxf', 'application/x-lenexdatei');

case 'vr_lenex':
	$query = "SELECT z.id as zid, m.vorname, m.nachname, m.mw, CONCAT(YEAR(m.gebdatum),'-01-01') as mdatum, m.dsvid,
				  z.zeit, z.streckenlaenge, z.disziplin, w.ort, w.titel, DATE_FORMAT(z.datum, '%Y-%m-%d') as zdatum
				FROM ((".DB_PREFIX."zeiten_rekorde as zr LEFT JOIN ".DB_PREFIX."zeiten as z ON zr.zeitid=z.id)
				  LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id)
				  LEFT JOIN ".DB_PREFIX."wettkaempfe as w ON z.wettkampfid=w.id
				WHERE zr.art='aVR' ORDER BY disziplin, streckenlaenge";
	$_db->holeDaten($query);
	if($_db->holeAnzahl()<1){
		$_tmpl->assign('fehler','Es wurden keine Vereinsrekorde gefunden');
		break;
	}
	$zeiten = $_db->baueArray('*','zid');
	$_lagen_en = array(
		1 => 'FREE',
		2 => 'BREAST',
		3 => 'BACK',
		4 => 'FLY',
		5 => 'MEDLEY'
	);
	$inhalt = '<?xml version="1.0" encoding="UTF-8"?>'.BR;
	$inhalt .= '<LENEX version="2.0">'.BR;
	$inhalt .= ' <CONSTRUCTOR name="tkswim" version="'.TKSWIM_VERSION.'">'.BR;
	$inhalt .= '  <CONTACT name="Tobias Kloth" country="GER" email="" internet="http://tkswim.de/" />'.BR;
	$inhalt .= ' </CONSTRUCTOR>'.BR;
	$inhalt .= ' <RECORDLISTS>'.BR;
	$rekorde = array('m'=>'','w'=>'');
	$neuesterrekord = array('m'=>'0000-00-00','w'=>'0000-00-00');
	foreach($zeiten as $row){
		if($row['zdatum'] > $neuesterrekord[$row['mw']]){
			$neuesterrekord[$row['mw']] = $row['zdatum'];
		}
		$rekorde[$row['mw']] .= '    <RECORD swimtime="00:'.text_format($row['zeit'],'schwimmzeit').'">'.BR;
		$rekorde[$row['mw']] .= '     <SWIMSTYLE relaycount="1" distance="'.$row['streckenlaenge'].'" stroke="'.$_lagen_en[$row['disziplin']].'" />'.BR;
		$rekorde[$row['mw']] .= '     <MEETINFO city="'.text_format($row['ort'], 'xml').'" date="'.$row['zdatum'].'" name="'.text_format($row['titel'], 'xml').'" nation="GER" />'.BR;
		$rekorde[$row['mw']] .= '     <ATHLETE birthdate="'.$row['mdatum'].'" firstname="'.text_format($row['vorname'], 'xml').'" gender="'.($row['mw']=='m'?'M':'F').'" lastname="'.text_format($row['nachname'], 'xml').'"'.(!is_null($row['dsvid'])?' passport="'.$row['dsvid'].'"':'').' />'.BR;
		$rekorde[$row['mw']] .= '    </RECORD>'.BR;
	}
	/* VR - männlich */
	$inhalt .= '  <RECORDLIST course="OPEN" gender="M" name="Vereinsrekorde" updated="'.$neuesterrekord['m'].'">'.BR;
	$inhalt .= '   <RECORDS>'.BR;
	$inhalt .= $rekorde['m'];
	$inhalt .= '   </RECORDS>'.BR;
	$inhalt .= '  </RECORDLIST>'.BR;
	/* VR - weiblich */
	$inhalt .= '  <RECORDLIST course="OPEN" gender="F" name="Vereinsrekorde" updated="'.$neuesterrekord['w'].'">'.BR;
	$inhalt .= '   <RECORDS>'.BR;
	$inhalt .= $rekorde['w'];
	$inhalt .= '   </RECORDS>'.BR;
	$inhalt .= '  </RECORDLIST>'.BR;
	$inhalt .= ' </RECORDLISTS>'.BR;
	$inhalt .= '</LENEX>'.BR;

	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($inhalt, 'vereinsrekorde.lef', time());
	$zipinh = $zip->gebeDateiAus('vereinsrekorde.lxf', 'application/x-lenexdatei');
	exit;

default:
	$_inh .= $_tmpl->fetch('export/71.vereinsrekorde.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>