<?php
require_once('../__inc/_start.inc.php');
$_seite = 16;
$erlaubt = pruefeRechte('m_familien_anzeigen');
$titel = 'Familien';
$_tmpl->assign('ueberschrift','Familien');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'bereinigen':
	if(!pruefeRechte('m_familien_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Familie bereinigen');
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll die Familie wirklich bereinigt werden?');
		$_tmpl->assign('query','id='.$_GET['id']);
		$_tmpl->assign('url', '/mitglieder/familien'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "UPDATE ".DB_PREFIX."mitglieder SET familienid = 0 WHERE familienid = '".text_format($_GET['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		weiterleiten('/mitglieder/familien'.TKSWIM_DATEIENDUNG,'Die Familie wurde erfolgreich bereinigt');
	}
	break;
case 'loeschen':
	if(!pruefeRechte('m_familien_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Familie löschen');
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll die Familie wirklich gelöscht werden');
		$_tmpl->assign('query','id='.$_GET['id']);
		$_tmpl->assign('url', '/mitglieder/familien'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "DELETE FROM ".DB_PREFIX."familien WHERE id = ".text_format($_GET['id'],'db')."";
		$_db->fuehreQueryAus($query);
		weiterleiten('/mitglieder/familien'.TKSWIM_DATEIENDUNG,'Die Familie wurde erfolgreich gelöscht');
	}
	break;
case 'aendern':
	if(!pruefeRechte('m_familien_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Familie ändern');
	if(!isset($_POST['speichern'])){
		$query = "SELECT id, titel FROM ".DB_PREFIX."familien WHERE id = ".text_format($_GET['id'],'db')."";
		$_db->holeDaten($query);
		$_tmpl->assign('daten',$_db->holeZeile());
	}
	else{
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f .= pruefen($_POST['titel'],'leer','Der Titel fehlt');
		$f .= pruefen($_POST['titel'],'minlaenge','Der Titel muss aus mindestens 2 Zeichen bestehen',2);
		$f .= pruefen($_POST['titel'],'maxlaenge','Der Titel darf aus höchstens 100 Zeichen bestehen',100);
		if(empty($f)){
			$query = "UPDATE ".DB_PREFIX."familien
						SET titel = '".text_format($_POST['titel'],'db')."'
						WHERE id = ".text_format($_GET['id'],'db')."";
			$_db->fuehreQueryAus($query);
			weiterleiten('/mitglieder/familien'.TKSWIM_DATEIENDUNG,'Die Familie »'.$_POST['titel'].'« wurde geändert');
		}
		else{
			$_tmpl->assign('daten',$_POST);
			$_tmpl->assign('fehler',$f);
		}
	}
	$_inh .= $_tmpl->fetch('mitglieder/16.familien-formular.inc.html');
	break;
case 'anlegen':
	if(!pruefeRechte('m_familien_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Familie anlegen');
	if(isset($_POST['speichern'])){
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f .= pruefen($_POST['titel'],'leer','Der Titel fehlt');
		$f .= pruefen($_POST['titel'],'minlaenge','Der Titel muss aus mindestens 2 Zeichen bestehen',2);
		$f .= pruefen($_POST['titel'],'maxlaenge','Der Titel darf aus höchstens 100 Zeichen bestehen',100);
		$query = "SELECT id FROM ".DB_PREFIX."familien WHERE titel = '".$_POST['titel']."'";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] != 0){
			$f .= 'Die Familie existiert schon<br />';
		}
		if(empty($f)){
			$query = "INSERT INTO ".DB_PREFIX."familien
						SET titel = '".text_format($_POST['titel'],'db')."'";
			$_db->fuehreQueryAus($query);
			$text = 'Die Familie »'.$_POST['titel'].'« wurde angelegt';
			if(!isset($_POST['anschl']) OR (isset($_POST['anschl']) AND $_POST['anschl'] == 'uebers')){
				weiterleiten('/mitglieder/familien'.TKSWIM_DATEIENDUNG,$text);
			}
			else{
				weiterleiten('/mitglieder/familien'.TKSWIM_DATEIENDUNG.'?aktion=anlegen',$text);
			}
		}
		else{
			$_tmpl->assign('daten',$_POST);
			$_tmpl->assign('fehler',$f);
		}
	}
	$_inh .= $_tmpl->fetch('mitglieder/16.familien-formular.inc.html');
	break;
default:
	$query = "SELECT id FROM ".DB_PREFIX."familien";
	$_db->holeDaten($query);
	$anzahl = $_db->ergebnis['anzahl'];
	$s = 1;
	$proseite = $_einst['globaleeinstellungen']['blaetternseiten']!=0?$_einst['globaleeinstellungen']['blaetternseiten']:25;
	if(isset($_GET['seite']) and $_GET['seite'] == 'alle'){
		$s = 'alle';
	}
	elseif(isset($_GET['seite']) and ctype_digit($_GET['seite']) and $_GET['seite']!=0){
		if($proseite*($_GET['seite']-1) > $anzahl){
			$s = ceil($anzahl/$proseite);
		}
		else{
			$s = (int)$_GET['seite'];
		}
	}
	$_tmpl->assign('blaettern',array('anzahl'=>$anzahl,'seite'=>$s,'proseite'=>$proseite));
	$_tmpl->assign('ueberschrift','Familienübersicht');
	$query = "SELECT f.id, f.titel, count(m.familienid) AS anzahl
				FROM ".DB_PREFIX."familien AS f LEFT JOIN ".DB_PREFIX."mitglieder AS m ON f.id = m.familienid
				GROUP BY f.id ORDER BY f.titel ".($s!='alle'?'LIMIT '.((($s-1)*$proseite).",".$proseite):'')."";
	$_db->holedaten($query);
	$_tmpl->assign('familien',$_db->ergebnis['daten']);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.bereinigen').tkswim_loeschfrage({frage:'Sollen wirklich alle Verknüpfungen zu den Familienmitgliedern gelöscht werden?',ajax:false});");
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'familien',frage:'Soll die Familie%%% wirklich gelöscht werden?',tabellenid:'familie'});");
	$_inh .= $_tmpl->fetch('mitglieder/16.familien-uebersicht.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>